theory Diagonals
  imports Main
begin

definition diag :: "'a set \<Rightarrow> ('a \<times> 'a) set" ("(_\<^sup>d)" [1000] 999)
  where
  "diag p = (p \<times> p) \<inter> Id"


lemma diag_ext:
  "p\<^sup>d = {(x, x) | x. x \<in> p}"
  by(auto simp add: diag_def)

lemma diag_Id:
  "p\<^sup>d \<subseteq> Id"
  by(auto simp add: diag_def)

lemma diag_emp [simp]:
  "{}\<^sup>d = {}"
  by(auto simp add: diag_def)

lemma diag_UNIV [simp]:
  "UNIV\<^sup>d = Id"
  by(auto simp add: diag_def)

lemma diag_singleton:
  "{x}\<^sup>d = {(x, x)}"
  by(auto simp add: diag_def)

lemma diag_int_distrib:
  "(p \<inter> q)\<^sup>d = p\<^sup>d \<inter> q\<^sup>d"
  by(auto simp add: diag_def)

lemma diag_int_distrib2:
  "(p \<inter> q)\<^sup>d = p\<^sup>d O q\<^sup>d"
  by(auto simp add: diag_def)

lemma diag_Int_distrib:
  "(\<Inter> a. p a)\<^sup>d = (\<Inter> a. (p a)\<^sup>d)"
  by(auto simp add: diag_def)

lemma diag_Union_distrib:
  "(\<Union> x. p x)\<^sup>d = (\<Union> x. (p x)\<^sup>d)"
  by(auto simp add: diag_def)

lemma diag_p_incl:
  "(s, s') \<in> p\<^sup>d \<longleftrightarrow> s = s' \<and> s \<in> p"
  by(auto simp add: diag_def)

lemma Range_diag [simp]:
  "Range (p\<^sup>d) = p"
  by(auto simp add: diag_def)

lemma Domain_diag [simp]:
  "Domain (p\<^sup>d) = p"
  by(auto simp add: diag_def)

lemma diag_mono:
  "p \<subseteq> q \<Longrightarrow> p\<^sup>d \<subseteq> q\<^sup>d"
  by(auto simp add: diag_def)

lemma diag_act_ext:
  "p\<^sup>d O a = {(x, y) | x y. x \<in> p} \<inter> a"
  by(auto simp add: diag_def)

lemma diag_subs:
  assumes "p\<^sup>d O a \<subseteq> b"
  shows "p\<^sup>d O a \<subseteq> p\<^sup>d O b"
  using assms by(fastforce simp add: diag_def)

lemma diag_pre_cases:
  shows "a = p\<^sup>d O a \<union> (-p)\<^sup>d O a"
  by(fastforce simp add: diag_def)
  
lemma diag_post_cases:
  shows "a =  a O p\<^sup>d \<union> a O (-p)\<^sup>d"
  by(fastforce simp add: diag_def)

lemma
  "Domain (a O b) = Domain (a O (Domain b)\<^sup>d)"
  by(fastforce simp add: diag_def)

end