theory RCU
  imports COComp
begin

consts mbb :: nat

context MPSync
begin

 

datatype PC = L1 | L2 | L3 | L4 | L5| L6 | L7 | L8 |  End

definition "T1 = (1 :: nat)"
definition "T2 = (2 :: nat)"


lemma T_neq [simp]: "T1 = T2 \<longleftrightarrow> False"
  by(auto simp add: T1_def T2_def)


fun rcu :: "V \<Rightarrow> R \<Rightarrow> R \<Rightarrow> R \<Rightarrow> R \<Rightarrow> R \<Rightarrow>  L \<Rightarrow> L \<Rightarrow> L \<Rightarrow> L \<Rightarrow> L \<Rightarrow> T \<Rightarrow> PC \<Rightarrow> PC AComm"
  where
  "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L1 =
                      
                       (if t = T1 then storec False m ((mb mod 2) + 1) L2 else
                        if t = T2 then test (reg rr2 0) L2 End else skip)" |

  "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L2 =

                       (if t = T1 then storec True w 1 L3 else
                        if t = T2 then loadc False rr1 m L3 else skip)"  |

  "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L3 =

                        (if t = T1 then loadc False wr r L4 else
                        if t = T2 then  test (reg rr1 1) L4 L5 else skip)"  |

  "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L4 =

                        (if t = T1 then test (reg wr 1) L5 L3 else
                        if t = T2 then loadc False a n1 L6 else skip)"  |

  "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L5 =

                        (if t = T1 then test (reg mbr 1) L6 L7 else
                        if t = T2 then loadc False a n2 L6 else skip)"  |

  "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L6 =

                        (if t = T1 then storec False n1 0 End  else
                        if t = T2 then loadc True rr2 w L7 else skip)"  |
 
 "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L7 =

                        (if t = T1 then storec False n2 0 End else
                        if t = T2 then storee False r (\<lambda> rf. rf rr2) L8 else skip)"  |

 "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t L8 =

                        (if t = T1 then skip  else
                        if t = T2 then test (reg rr2 0) L2 End else skip)"  |

 "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t End = skip"

abbreviation "exp_rr1 rr10 mb0 \<equiv> {rf . rf rr10 = ((rf mb0) mod  2) + 1}"

definition "r_inv  mb0 mbr0  wr0 rr10 rr20 a0 m0 w0 r0 n10 n20 \<equiv>  
lift\<^sub>1(constrained_value T2 w0 {0,1}) \<inter>
lift\<^sub>1(constrained_value T2 m0 {1,2}) \<inter>
lift\<^sub>1((\<langle>G (T2, R True w0 1)\<rangle> (synced T2 w0 1))) \<inter>
lift\<^sub>1((\<langle>G (T2, R True w0 1)\<rangle> (synced T2 m0 ((mb0 mod 2) + 1)))) \<inter> 
(Reg T2 (- reg rr20 1) \<union> (lift\<^sub>1(synced T2 m0 ((mb0 mod 2) + 1)) \<inter> lift\<^sub>1(synced T2 w0 1))) \<inter> 
(lift\<^sub>1(not_value T1 r0 1 ) \<union> Reg T2 (reg rr20 1)) \<inter>
(Reg T2 (- reg a0 0)) \<inter>
((lift\<^sub>1(not_value T2 n10 0) \<inter> lift\<^sub>1(not_value T2 n20 0) \<inter> (Reg T1 (reg wr0 0))) 
  \<union> 
  ((Reg T2 (reg rr20 1)) 
    \<inter> (Reg T1 (-reg mbr0 1) \<union> lift\<^sub>1(not_value T2 n20 0)) 
    \<inter> (Reg T1 (-reg mbr0 2) \<union> lift\<^sub>1(not_value T2 n10 0))))
"
 \<comment> \<open> \<inter> ((Reg T2 (-reg mb0 1)) \<union> (lift1(not_value T2 n20 0)))  \<inter> ((Reg T2 (-reg mb0 2)) \<union> (lift1(not_value T2 n10 0)))))\<close>

definition "mb_reg v r \<equiv> Reg T1 (reg r v) \<inter>  Reg T2 (reg r v)"

lemmas s[simp] = mb_reg_def

definition outline :: "V \<Rightarrow> R \<Rightarrow> R \<Rightarrow> R \<Rightarrow> R \<Rightarrow> R \<Rightarrow>  L \<Rightarrow> L \<Rightarrow> L \<Rightarrow> L \<Rightarrow> L \<Rightarrow> T \<Rightarrow> PC \<Rightarrow> (('b, PC) full_state) set"
  where
"outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc \<equiv> 
              case pc of
                   L1 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> lift\<^sub>1(synced T1 w 0) \<inter> lift\<^sub>1(not_value T2 w 1) \<inter> lift\<^sub>1(synced T1 m mb) \<inter> 
                                           lift\<^sub>1(synced T2 m mb) \<inter> \<comment> \<open>new\<close>
                                          lift\<^sub>1(constrained_value T1 r {0,1}) else                       
                          
                          (if t = T2 then mb_reg mb mbr \<inter> lift\<^sub>1(constrained_value T2 w {0,1}) \<inter>
                                          lift\<^sub>1(constrained_value T2 m {1,2}) \<inter>
                                          (lift\<^sub>1(synced T1 r 0)) \<inter>
                                          lift\<^sub>1((\<langle>G (T2, R True w 1)\<rangle> (synced T2 w 1))) \<inter>
                                          lift\<^sub>1((\<langle>G (T2, R True w 1)\<rangle> (synced T2 m ((mb mod 2) + 1)))) \<inter>  
                                          (lift\<^sub>1(not_value T2 w 1) \<union> lift\<^sub>1(synced T1 w 1)) \<inter>
                                          (Reg T2 (reg rr1 0)) \<inter> (Reg T2 (reg rr2  0))  \<inter> (Reg T1 (reg wr 0)) \<inter> 
                                          (Reg T2 (-reg a 0)) \<inter>
                                          lift\<^sub>1(not_value T2 n1 0)  \<inter> lift\<^sub>1(not_value T2 n2 0) else {})) |

                   L2 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> lift\<^sub>1(synced T1 w 0) \<inter> lift\<^sub>1(not_value T2 w 1) \<inter> lift\<^sub>1(synced T1 m ((mb mod 2)+1)) \<inter>
                                          lift\<^sub>1(constrained_value T1 r {0,1})  else
                         
                          (if t = T2 then mb_reg mb mbr \<inter> r_inv mb mbr wr rr1 rr2 a m w r n1 n2  else {})) |
                  
                   L3 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> lift\<^sub>1(constrained_value T1 r {0,1}) else 
                        
                          (if t = T2 then mb_reg mb mbr \<inter> r_inv mb mbr wr rr1 rr2 a m w r n1 n2 \<inter> 
                          ((Reg T2 (-reg rr2 1)) \<union> Reg T2 (reg rr1 ((mb mod 2)+1))) \<inter>
                          (Reg T2 (reg rr1 1) \<union> Reg T2 (reg rr1 2))
                          else {})) |
                  
                   L4 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> lift\<^sub>1(constrained_value T1 r {0,1}) else 
                       
                          (if t = T2 then mb_reg mb mbr \<inter> r_inv mb mbr  wr rr1 rr2 a m w r n1 n2 \<inter> ((Reg T2 (-reg rr2 1)) \<union> Reg T2 (reg rr1 ((mb mod 2)+1))) \<inter> 
                          (Reg T2 (reg rr1 1)) else {})) |
                  
                   L5 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> (Reg T1 (reg wr 1)) else 
                          
                          (if t = T2 then mb_reg mb mbr \<inter> r_inv mb mbr wr rr1 rr2 a m w r n1 n2 \<inter> ((Reg T2 (-reg rr2 1)) \<union> Reg T2 (reg rr1 ((mb mod 2)+1))) \<inter>
                          (Reg T2 (reg rr1 2)) else {})) |
                  
                   L6 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> (Reg T1 (reg wr 1)) \<inter> (Reg T1 (reg mbr 1))  else \<comment> \<open>\<inter> (Reg T1 (reg mb 1)) might need to express this in another way\<close>
                          (if t = T2 then mb_reg mb mbr \<inter> r_inv mb mbr wr rr1 rr2 a m w r n1 n2 else {})) |
                  
                   L7 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> (Reg T1 (reg wr 1)) \<inter> (Reg T1 (reg mbr 2))  else  \<comment> \<open>\<inter> (Reg T1 (reg mb 2))\<close>
                          (if t = T2 then mb_reg mb mbr \<inter> r_inv mb mbr wr rr1 rr2 a m w r n1 n2 \<inter> ((Reg T2 (reg rr2 0)) \<union> Reg T2 (reg rr2 1))  else {})) |
                  
                   L8 \<Rightarrow>  (if t = T1 then mb_reg mb mbr \<inter> (Reg T1 (reg wr 1))  else  \<comment> \<open>\<inter> (Reg T1 (reg mb 2))\<close>
                          (if t = T2 then mb_reg mb mbr \<inter> r_inv mb mbr wr rr1 rr2 a m w r n1 n2 \<inter> ((Reg T2 (reg rr2 0)) \<union> Reg T2 (reg rr2 1))  else {})) |

                   End \<Rightarrow> (if t = T1 then mb_reg mb mbr \<inter> UNIV else
                          (if t = T2 then mb_reg mb mbr \<inter> Reg T2 (- reg a 0 ) else {}))"

lemma outline_disj_arb_pres:
  "lift\<^sub>1 (not_value T2 w (Suc 0)) \<union> lift\<^sub>1 (synced T1 w (Suc 0))
      \<subseteq> \<langle>arb_pc t'\<rangle> (lift\<^sub>1 (not_value T2 w (Suc 0)) \<union> lift\<^sub>1 (synced T1 w (Suc 0)))"
  using wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 Reg_pres_arb_pc lift\<^sub>1_pres_arb_pc
  by (simp add: lift\<^sub>1_pres_arb_pc wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)

lemma rinv_arb_pc:
  assumes "mb\<in>{1,2}"
  shows "r_inv mb0 mbr0  wr0 rr10 rr20 a0 m0 w0 r0 n10 n20 \<subseteq> \<langle>arb_pc t'\<rangle> (r_inv mb0 mbr0  wr0 rr10 rr20 a0 m0 w0 r0 n10 n20)"
  apply(simp add: r_inv_def)
  using Reg_pres_arb_pc lift\<^sub>1_pres_arb_pc
         apply -
  apply(rule wp_ir_pr_conj_intro)+
  apply (simp add: lift\<^sub>1_pres_arb_pc wp_ir_pr_conj_elim1)
        apply (simp add: lift\<^sub>1_pres_arb_pc wp_ir_pr_conj_elim1  wp_ir_pr_conj_elim5)
        apply (simp add: lift\<^sub>1_pres_arb_pc wp_ir_pr_conj_elim1  wp_ir_pr_conj_elim5)
        apply (simp add: lift\<^sub>1_pres_arb_pc wp_ir_pr_conj_elim1  wp_ir_pr_conj_elim5)
     apply (simp add: lift\<^sub>1_pres_arb_pc wp_ir_pr_conj_elim1  wp_ir_pr_conj_elim5)
  apply(rule basic_wp_pres)
  apply (simp add: Reg_pres_arb_pc le_infI1 lift\<^sub>1_pres_arb_pc wp_ir_pr_conj_elim2 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pt(15))
     apply blast
apply(rule basic_wp_pres) 
  apply (smt Reg_pres_arb_pc Un_subset_iff lift\<^sub>1_pres_arb_pc subset_trans wp_pred_sup_semi_distrib)
  apply blast 
apply(rule basic_wp_pres) 
  apply (simp add: Reg_pres_arb_pc) 
  apply blast 
apply(rule basic_wp_pres) apply(rule basic_wp_pres_disj)
  apply (smt Int_lower1 Int_lower2 Reg_pres_arb_pc basic_wp_pres basic_wp_pres_disj lift\<^sub>1_pres_arb_pc wp_ir_pr_conj_intro)
  apply (smt Int_lower1 Int_lower2 Reg_pres_arb_pc lift\<^sub>1_pres_arb_pc subset_trans wp_pred_int_pres)
  by blast

lemma outline_arb_pc:
  assumes "mb\<in>{1,2}"
    and "t\<in>{T1,T2}"
  shows "outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc \<subseteq> \<langle>arb_pc t'\<rangle> (outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc)"
  apply(cases "t = T1")
  apply(case_tac pc; simp)
          apply(simp add: outline_def)
  using Reg_pres_arb_pc lift\<^sub>1_pres_arb_pc
         apply -
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
          apply(simp add: outline_def)
         apply((rule wp_ir_pr_conj_intro)+; fastforce)
apply(cases "t = T2")
          apply(simp add: outline_def)
  using Reg_pres_arb_pc lift\<^sub>1_pres_arb_pc T_neq Int_lower1 Int_subset_iff 
  apply(case_tac pc; simp)
           apply -
  apply(rule wp_ir_pr_conj_intro)+
   apply fastforce apply fastforce apply fastforce apply fastforce
                    apply fastforce apply fastforce apply fastforce 
  using outline_disj_arb_pres apply (smt Int_lower1 Int_subset_iff subset_trans)
                apply fastforce apply fastforce apply fastforce apply fastforce apply fastforce
   apply fastforce using rinv_arb_pc
  apply (smt Int_lower1 Int_lower2 assms subset_trans wp_pred_int_pres)
  apply(rule wp_ir_pr_conj_intro)+
  apply blast 
  apply blast 
  apply (smt assms rinv_arb_pc wp_ir_pr_conj_elim1 wp_ir_pr_conj_elim5)
          apply (smt Int_lower1 Int_subset_iff basic_wp_pres basic_wp_pres_disj)
  apply (smt basic_wp_pres_disj wp_ir_pr_conj_elim2)
  apply(rule wp_ir_pr_conj_intro)+
  apply blast
  apply blast
  apply (smt Int_lower2 assms basic_wp_pres le_infI1 rinv_arb_pc)
  apply (smt Int_lower1 Int_subset_iff basic_wp_pres basic_wp_pres_disj)
  apply (simp add: wp_ir_pr_conj_elim2)
  apply(rule wp_ir_pr_conj_intro)+
  apply blast
  apply blast
  apply (smt Int_lower2 assms basic_wp_pres le_infI1 rinv_arb_pc)
  apply (smt Int_lower1 Int_subset_iff basic_wp_pres basic_wp_pres_disj)
  apply blast
  apply (smt Int_lower1 Int_lower2 assms rinv_arb_pc subset_trans wp_pred_int_pres)
  apply(rule wp_ir_pr_conj_intro)+ 
  apply blast 
  apply blast 
  apply (smt Int_lower2 assms basic_wp_pres rinv_arb_pc wp_ir_pr_conj_elim3)
  apply (smt basic_wp_pres_disj wp_ir_pr_conj_elim2)
  apply(rule wp_ir_pr_conj_intro)+ 
  apply blast 
  apply blast 
     apply (smt Int_lower2 assms basic_wp_pres rinv_arb_pc wp_ir_pr_conj_elim3)
  apply (smt basic_wp_pres_disj wp_ir_pr_conj_elim2)
   apply (smt Int_lower1 Int_lower2 dual_order.trans wp_pred_int_pres)
  using assms(2) by blast

lemma constrained_value_load_wp:
  shows "lift\<^sub>1(constrained_value t x V) \<subseteq> \<langle>full_step Ts
            Pr
            (t, Some (load b x r v))\<rangle>
                     (\<Union> v\<in>V . Reg t {reg. reg r = v})"
  apply(auto simp add:Tr_def Rds_def lift\<^sub>1_def not_value_def 
        constrained_value_def full_step_def co_step_def mem_act_def 
        par_step_def Reg_def lift\<^sub>2_def lift_t_def  wp_ext)
  by force

lemma Reg_not_not_Reg: "-Reg t (reg r v) = Reg t (-reg r v)"
  by(auto simp add: Reg_def lift_t_def lift\<^sub>2_def)

lemma P_nP_Q_P_Q: "P \<inter> (-P \<union> Q) = P \<inter> Q"
  by auto

lemma constrained_value_load_not_in: "v\<notin>V \<Longrightarrow>  lift\<^sub>1 (constrained_value t x V)
       \<subseteq> \<langle>full_step Ts Pr
            (t, Some (load b x r v))\<rangle> {}"
  by (smt R_Rds constrained_value_implies_not_value lift\<^sub>1_mono load_wp_Reg_neg not_value_def pres_intro subsetD wp_emp_not_trans)

lemma load_wp_empty_q: "lift\<^sub>1 (constrained_value t x V)
       \<subseteq> \<langle>full_step Ts Pr
            (t, Some (load b x r v))\<rangle> {} \<Longrightarrow>
 lift\<^sub>1 (constrained_value t x V)
       \<subseteq> \<langle>full_step Ts Pr
            (t, Some (load b x r v))\<rangle> Q"
  by (meson empty_subsetI interpolation_right)

lemma bool_alg_inf1:
  "A = k \<inter> a \<Longrightarrow> A \<inter> b = k \<inter> (a \<inter> b)" by blast


lemma local_correctness_rcu:
  assumes "d \<noteq> f"
    and "rr1 \<noteq> rr2"
  and "mb\<in>{1,2}"
  and "a \<noteq> rr1"
  and "m \<noteq> n1"
  and "m \<noteq> n2"
  and "n1 \<noteq> n2"
  and "wr \<noteq> rr1"
  and "a \<noteq> rr1"
  and "a \<noteq> rr2"
  and "mbr \<noteq> a"
  and "mbr \<noteq> rr1"
  and "mbr \<noteq> rr2"
  and "mbr \<noteq> wr"
  and "wr \<noteq> a"
  and "wr \<noteq> rr2"
  and "w \<noteq> m"
  and "r \<noteq> m"
  and "r \<noteq> w"
  and "n1 \<noteq> r"
  and "n2 \<noteq> r"
  shows "local_correctness  {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 n2) (outline mb mbr wr rr1 rr2 a m w r n1 n2) t"
  apply(rule local_correctness_cases)
  using outline_arb_pc 
  using assms(3) apply fastforce
                apply(simp add: outline_def) 
       apply(case_tac pc;case_tac "t = T1";intro impI conjI; simp)
       apply(simp add: r_inv_def)
       apply(intro conjI)
  apply blast+
          apply( simp add: Reg_def lift\<^sub>2_def  lift\<^sub>1_def lift_t_def synced_def)
              apply auto[1]
  apply(subgoal_tac "lift\<^sub>1 (synced T1 r 0)
       \<subseteq> lift\<^sub>1 (not_value T1 r (Suc 0))")
              apply blast
  apply (simp add: initial_not_value lift\<^sub>1_mono not_value_def)
            apply blast+
              apply(simp add: outline_def) 
      apply(case_tac pc;case_tac "t = T1";intro impI conjI; simp)
       apply blast+
       apply(intro conjI)
  apply (simp add: le_infI1)
  
            apply (simp add: inf.coboundedI1)
            apply blast
  apply blast
  apply (metis (no_types, lifting) double_compl inf_sup_aci(2) le_infI2 reg_neg_P)
          apply blast+
        apply(intro conjI)
          apply blast+
  using T_neq apply auto[1]
        apply(intro conjI)
          apply blast+
  using assms  
  using Reg_not_not_Reg apply fastforce

     apply(simp add: r_inv_def)
    apply(intro conjI)
        apply blast+
        apply(simp add: outline_def)
  apply(case_tac pc;case_tac "t = T1";intro impI conjI; simp)
          apply(simp add: r_inv_def)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
            apply(rule wp_ir_pr_conj_intro)
            apply(rule wp_ir_pr_conj_intro)
  
  apply (metis Int_absorb act_wp_Reg_stable_other wp_ir_pr_conj_elim3)
          apply(rule wp_ir_pr_conj_elim1)  
  apply (metis assms(12) le_infI2 load_wp_Reg_other)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
                  apply(rule wp_ir_pr_conj_intro)
                  apply(rule wp_ir_pr_conj_intro)
                   

  apply (smt Int_commute Int_left_commute constrained_value_stable_load inf.coboundedI1)
  apply (smt Int_commute Int_left_commute constrained_value_stable_load inf.coboundedI1)
  using cobs_pres_load 
                 apply blast
  using cobs_pres_load 
                apply blast
               apply(subgoal_tac " (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 x (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0)))\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 x (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0)))")  
                apply blast
  apply(rule wp_ir_pr_disj_elim)
          apply(rule wp_ir_pr_disj_intro1)  
  apply (metis assms(2) load_wp_Reg5)
          apply(rule wp_ir_pr_disj_intro2)  
               apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_elim1)
  apply ( simp add: load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply(rule wp_ir_pr_conj_elim2)
               apply ( simp add: load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply(subgoal_tac "(lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
            Reg T2 {reg. reg rr2 = Suc 0})\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
            Reg T2 {reg. reg rr2 = Suc 0})")
  apply blast
  apply(rule wp_ir_pr_disj_elim)
          apply(rule wp_ir_pr_disj_intro1)  
               apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
          apply(rule wp_ir_pr_disj_intro2)  
  using assms(2) load_wp_Reg_other apply blast
  apply(subgoal_tac "(Reg T2 (- {reg. reg a = 0})) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg a = 0}))")
              apply blast
  using assms(4) load_wp_Reg5 apply blast
  apply(subgoal_tac " (lift\<^sub>1 (not_value T2 n1 0) \<inter>
            lift\<^sub>1 (not_value T2 n2 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union>
             lift\<^sub>1 (not_value T2 n1 0)))
      \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter>
            lift\<^sub>1 (not_value T2 n2 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union>
             lift\<^sub>1 (not_value T2 n1 0)))")
             apply blast
  apply(rule wp_ir_pr_disj_elim)
             apply(rule wp_ir_pr_disj_intro1)  
            apply(rule wp_ir_pr_conj_intro)  
              apply(rule wp_ir_pr_conj_intro)  
  apply(subgoal_tac " lift\<^sub>1 (not_value T2 n1 0) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 n1 0))")
  apply blast
  using no_value_stable_diff_var
               apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac " lift\<^sub>1 (not_value T2 n2 0)\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 n2 0))")
  apply blast
  using no_value_stable_diff_var
  apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac "       Reg T1 {reg. reg wr = 0}
      \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T1 {reg. reg wr = 0})")
              apply blast
  apply (simp add: act_wp_Reg_stable_other)
            apply(rule wp_ir_pr_disj_intro2)
            apply(rule wp_ir_pr_conj_intro)
  apply(subgoal_tac " (Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n2 0)))\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n2 0)))")
  apply blast
            apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_elim1)
  using assms(2) load_wp_Reg_other apply blast
  apply(rule wp_ir_pr_conj_elim2)
             apply(rule wp_ir_pr_disj_elim)
            apply(rule wp_ir_pr_disj_intro1)
  using assms(12) load_wp_Reg5 apply blast
              apply(rule wp_ir_pr_disj_intro2)
             apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(rule wp_ir_pr_conj_elim2)
             apply(rule wp_ir_pr_disj_elim)
              apply(rule wp_ir_pr_disj_intro1)


  using assms(12) load_wp_Reg5 apply blast
              apply(rule wp_ir_pr_disj_intro2)
             apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac "(Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
         lift\<^sub>1 (synced T2 x (Suc (mb mod 2))) \<inter>
         lift\<^sub>1 (synced T2 w (Suc 0)))  \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            Reg T2 {reg. reg ra = Suc (mb mod 2)})")
  apply blast
                       apply(rule wp_ir_pr_disj_elim)
            apply(rule wp_ir_pr_disj_intro1) 
  apply (metis assms(2) load_wp_Reg5)
            apply(rule wp_ir_pr_disj_intro2) 
  apply(rule wp_ir_pr_conj_elim1)
           apply (metis load_wp_Reg load_wp_synced_value)
  apply(subgoal_tac " lift\<^sub>1 (constrained_value T2 x {Suc 0, 2})       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr ra rr2 a x w r n1 n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 {reg. reg ra = Suc 0} \<union>
            Reg T2 {reg. reg ra = 2})")
  apply blast
  using constrained_value_load_wp [where t=T2 and V="{1,2}" and r=rr1 and Pr="(rcu mb mbr wr rr1 rr2 a m w r n1 n2)"
    and b="False" and x=m  and Ts="{T1,T2}"]
  apply simp
  using T_neq apply auto[1]
        apply(rule wp_ir_pr_conj_intro)
         apply(rule wp_ir_pr_conj_elim1)
        apply(rule wp_ir_pr_conj_intro)
          apply (metis assms(14) le_infI1 load_wp_Reg_other)
  apply (simp add: act_wp_Reg_stable_other le_infI2)
    apply(rule wp_ir_pr_conj_elim2)
      apply (simp add: constrained_value_stable_load)
  apply(simp add: r_inv_def)
       apply(rule wp_ir_pr_conj_intro)
        apply(rule wp_ir_pr_conj_intro)

  apply (metis Int_absorb act_wp_Reg_stable_other wp_ir_pr_conj_elim3)
  apply(subgoal_tac "(Reg T2 {reg. reg mbr = mb})       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x
              n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 {reg. reg mbr = mb})")
  apply blast
  apply (metis assms(11) load_wp_Reg_other)
        apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
             apply(rule wp_ir_pr_conj_intro)
             apply(rule wp_ir_pr_conj_intro)
  apply(subgoal_tac " lift\<^sub>1 (constrained_value T2 w {0, Suc 0})
      \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (constrained_value T2 w {0, Suc 0}))")
  apply blast
              apply (simp add: constrained_value_stable_load)
  apply(subgoal_tac "lift\<^sub>1
             (constrained_value T2 m {Suc 0, 2})
              \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (constrained_value T2 m {Suc 0, 2}))")
  apply blast
             apply (simp add: constrained_value_stable_load)
  apply(subgoal_tac " lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 w (Suc 0)))   \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 w (Suc 0))))")
  apply blast
  apply (simp add: cobs_pres_load)
    apply(subgoal_tac " lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 m (Suc (mb mod 2))))  \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 m (Suc (mb mod 2)))))")
  apply blast
           apply (simp add: cobs_pres_load)
               apply(subgoal_tac "  (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0))) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0)))")  
                apply blast
  apply(rule wp_ir_pr_disj_elim)
           apply(rule wp_ir_pr_disj_intro1)  

  apply (metis assms(10) load_wp_Reg5) 
          apply(rule wp_ir_pr_disj_intro2)  
               apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_elim1)
  apply ( simp add: load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply(rule wp_ir_pr_conj_elim2)
               apply ( simp add: load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply(subgoal_tac "(lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
        Reg T2 {reg. reg rr2 = Suc 0})\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
            Reg T2 {reg. reg rr2 = Suc 0})")
  apply blast
  apply(rule wp_ir_pr_disj_elim)
          apply(rule wp_ir_pr_disj_intro1)  
               apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
          apply(rule wp_ir_pr_disj_intro2)  
  using assms load_wp_Reg_other apply blast


  apply(subgoal_tac "(Reg T1 {reg. reg mbr = mb} \<inter>
       Reg T2 {reg. reg mbr = mb} \<inter>lift\<^sub>1 (not_value T2 x 0) \<inter>
         lift\<^sub>1 (not_value T2 n2 0) \<inter>
         Reg T1 {reg. reg wr = 0}  \<inter>
((Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
        Reg T2 {reg. reg rr1 = Suc (mb mod 2)}) \<inter>
       Reg T2 {reg. reg rr1 = Suc 0})) \<union>
         (Reg T1 {reg. reg mbr = mb} \<inter>
       Reg T2 {reg. reg mbr = mb} \<inter> Reg T2 {reg. reg rr2 = Suc 0} \<inter>
         (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
          lift\<^sub>1 (not_value T2 n2 0)) \<inter>
         (Reg T1 (- {reg. reg mbr = 2}) \<union>
          lift\<^sub>1 (not_value T2 x 0))  \<inter>
((Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
        Reg T2 {reg. reg rr1 = Suc (mb mod 2)}) \<inter>
       Reg T2 {reg. reg rr1 = Suc 0}))
 \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))")
         apply blast
  apply(rule wp_ir_pr_disj_elim)
  using load_wp_Reg6 apply fastforce
 
  using P_nP_Q_P_Q[where P = "Reg T2 {reg. reg rr2 = Suc 0}" and 
                    Q = "Reg T2 {reg. reg rr1 = Suc (mb mod 2)}"] Reg_not_not_Reg
  apply (simp add: Reg_not_not_Reg)
  apply(subgoal_tac " Reg T1 {reg. reg mbr = mb} \<inter>
       Reg T2 {reg. reg rr2 = Suc 0} \<inter>
       (Reg T1 (- {reg. reg mbr = 2}) \<union>
        lift\<^sub>1 (not_value T2 x 0)) \<inter>
       ((Reg T2 {reg. reg rr1 = Suc (mb mod 2)}) \<inter>
        Reg T2 {reg. reg rr1 = Suc 0})
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))
")
         apply blast
  apply(case_tac "mb \<noteq> 2")
  apply(subgoal_tac "(Reg T2 {reg. reg rr1 = Suc (mb mod 2)} \<inter>
        Reg T2 {reg. reg rr1 = Suc 0}) = {}")
  apply(subgoal_tac "   {}    \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))")
  apply blast
          apply blast
  apply(subgoal_tac "Suc (mb mod 2) \<noteq> Suc 0")
  using assms(3)
          apply(simp add: Reg_def lift_t_def lift\<^sub>2_def)
  apply fastforce
   using assms(3)
          apply fastforce
   apply simp
  using P_nP_Q_P_Q[where P = "Reg T1 {reg. reg mbr = 2}" and 
                    Q = "lift\<^sub>1 (not_value T2 n1 0)"] Reg_not_not_Reg
        apply (simp add: Reg_not_not_Reg)
  apply(subgoal_tac "
       (lift\<^sub>1 (not_value T2 x 0))
       \<subseteq> \<langle>full_step {T1, T2} (rcu 2 mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))")
  apply blast 
        apply (simp add: load_wp_Reg6)
  apply(subgoal_tac " (lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0)))\<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0)))")
  apply blast
       apply(rule wp_ir_pr_disj_elim)  
          apply(rule wp_ir_pr_disj_intro1)  
          apply(rule wp_ir_pr_conj_intro)  
          apply(rule wp_ir_pr_conj_intro)  
       apply(rule wp_ir_pr_conj_elim1)  
       apply(rule wp_ir_pr_conj_elim1)  
          apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac "lift\<^sub>1 (not_value T2 n2 0) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 n2 0))")
  apply blast
         apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac "Reg T1 {reg. reg wr = 0}
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T1 {reg. reg wr = 0})")
         apply blast 
  
  apply (simp add: act_wp_Reg_stable_other)
          apply(rule wp_ir_pr_disj_intro2)  
          apply(rule wp_ir_pr_conj_intro)  
          apply(rule wp_ir_pr_conj_intro)  
  apply(subgoal_tac "(Reg T2 {reg. reg rr2 = Suc 0}) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 {reg. reg rr2 = Suc 0})")
          apply blast 
  using assms(10) load_wp_Reg_other apply blast
  apply(subgoal_tac "(Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
        lift\<^sub>1 (not_value T2 n2 0))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
            lift\<^sub>1 (not_value T2 n2 0))")
         apply blast
        apply(rule wp_ir_pr_disj_elim) 
         apply(rule wp_ir_pr_disj_intro1) 
  using assms(11) load_wp_Reg5 apply blast
          apply(rule wp_ir_pr_disj_intro2) 
  apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac "   (Reg T1 (- {reg. reg mbr = 2}) \<union>
        lift\<^sub>1 (not_value T2 x 0))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r x n2)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T1 (- {reg. reg mbr = 2}) \<union>
            lift\<^sub>1 (not_value T2 x 0))")
  apply blast
        apply(rule wp_ir_pr_disj_elim) 
         apply(rule wp_ir_pr_disj_intro1) 
  using assms(11) load_wp_Reg5 apply blast
          apply(rule wp_ir_pr_disj_intro2) 
       apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
\<comment> \<open>proof of load for pc=5\<close>
  apply(simp add: r_inv_def)
       apply(rule wp_ir_pr_conj_intro)
        apply(rule wp_ir_pr_conj_intro)

  apply (metis Int_absorb act_wp_Reg_stable_other wp_ir_pr_conj_elim3)
  apply(subgoal_tac "(Reg T2 {reg. reg mbr = mb})\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 {reg. reg mbr = mb})")
  apply blast
  apply (metis assms(11) load_wp_Reg_other)
        apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
             apply(rule wp_ir_pr_conj_intro)
             apply(rule wp_ir_pr_conj_intro)
  apply(subgoal_tac " lift\<^sub>1 (constrained_value T2 w {0, Suc 0})
     \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (constrained_value T2 w {0, Suc 0}))")
  apply blast
              apply (simp add: constrained_value_stable_load)
  apply(subgoal_tac "lift\<^sub>1
             (constrained_value T2 m {Suc 0, 2})
             \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (constrained_value T2 m {Suc 0, 2}))")
  apply blast
             apply (simp add: constrained_value_stable_load)
  apply(subgoal_tac " lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 w (Suc 0)))  \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 w (Suc 0))))")
  apply blast
  apply (simp add: cobs_pres_load)
    apply(subgoal_tac " lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 m (Suc (mb mod 2)))) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1
             (\<langle>G (T2, R True w (Suc 0))\<rangle>
               (synced T2 m (Suc (mb mod 2)))))")
  apply blast
           apply (simp add: cobs_pres_load)
               apply(subgoal_tac "  (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0)))\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1
             (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0)))")  
                apply blast
  apply(rule wp_ir_pr_disj_elim)
           apply(rule wp_ir_pr_disj_intro1)  

  apply (metis assms(10) load_wp_Reg5) 
          apply(rule wp_ir_pr_disj_intro2)  
               apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_elim1)
  apply ( simp add: load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply(rule wp_ir_pr_conj_elim2)
               apply ( simp add: load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply(subgoal_tac "(lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
        Reg T2 {reg. reg rr2 = Suc 0})\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
            Reg T2 {reg. reg rr2 = Suc 0})")
  apply blast
  apply(rule wp_ir_pr_disj_elim)
          apply(rule wp_ir_pr_disj_intro1)  
               apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
          apply(rule wp_ir_pr_disj_intro2)  
  using assms load_wp_Reg_other apply blast


  apply(subgoal_tac "(Reg T1 {reg. reg mbr = mb} \<inter>
       Reg T2 {reg. reg mbr = mb} \<inter>lift\<^sub>1 (not_value T2 n1 0) \<inter>
         lift\<^sub>1 (not_value T2 x 0) \<inter>
         Reg T1 {reg. reg wr = 0}  \<inter>
((Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
        Reg T2 {reg. reg rr1 = Suc (mb mod 2)}) \<inter>
       Reg T2 {reg. reg rr1 = 2})) \<union>
         (Reg T1 {reg. reg mbr = mb} \<inter>
       Reg T1 {reg. reg mbr = mb} \<inter> Reg T2 {reg. reg rr2 = Suc 0} \<inter>
         (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
          lift\<^sub>1 (not_value T2 x 0)) \<inter>
         (Reg T1 (- {reg. reg mbr = 2}) \<union>
          lift\<^sub>1 (not_value T2 n1 0))  \<inter>
((Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
        Reg T2 {reg. reg rr1 = Suc (mb mod 2)}) \<inter>
       Reg T2 {reg. reg rr1 = 2}))
 \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))")

         apply blast
  apply(rule wp_ir_pr_disj_elim)
  using load_wp_Reg6 apply fastforce
 
  using P_nP_Q_P_Q[where P = "Reg T2 {reg. reg rr2 = Suc 0}" and 
                    Q = "Reg T2 {reg. reg rr1 = Suc (mb mod 2)}"] Reg_not_not_Reg
  apply (simp add: Reg_not_not_Reg)
  apply(subgoal_tac " Reg T1 {reg. reg mbr = mb} \<inter>
       Reg T1 {reg. reg mbr = mb} \<inter>
       Reg T2 {reg. reg rr2 = Suc 0} \<inter>
       (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
        lift\<^sub>1 (not_value T2 x 0)) \<inter>
       (Reg T1 (- {reg. reg mbr = 2}) \<union>
        lift\<^sub>1 (not_value T2 n1 0)) \<inter>
       ((         Reg T2
          {reg. reg rr1 = Suc (mb mod 2)}) \<inter>
        Reg T2 {reg. reg rr1 = 2})
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))
")
         apply blast
  apply(case_tac "mb \<noteq> 1")
  apply(subgoal_tac "(Reg T2 {reg. reg rr1 = Suc (mb mod 2)} \<inter>
        Reg T2 {reg. reg rr1 = 2}) = {}")
  apply(subgoal_tac "   {}    \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))")
  apply blast
          apply blast
  apply(subgoal_tac "Suc (mb mod 2) \<noteq> 2")
  using assms(3)
          apply(simp add: Reg_def lift_t_def lift\<^sub>2_def)
  apply fastforce
   using assms(3)
          apply fastforce
   apply simp
  using P_nP_Q_P_Q[where P = "Reg T1 {reg. reg mbr = Suc 0}" and 
                    Q = "lift\<^sub>1 (not_value T2 n2 0)"] Reg_not_not_Reg
        apply (simp add: Reg_not_not_Reg)
  apply(subgoal_tac "
       (lift\<^sub>1 (not_value T2 x 0))
       \<subseteq> \<langle>full_step {T1, T2} (rcu (Suc 0) mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = 0}))")
  apply blast 
        apply (simp add: load_wp_Reg6)
  apply(subgoal_tac " (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter>
            lift\<^sub>1 (not_value T2 x 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 x 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union>
             lift\<^sub>1 (not_value T2 n1 0)))")
  apply blast
       apply(rule wp_ir_pr_disj_elim)  
          apply(rule wp_ir_pr_disj_intro1)  
          apply(rule wp_ir_pr_conj_intro)  
          apply(rule wp_ir_pr_conj_intro)  
       apply(rule wp_ir_pr_conj_elim1)  
       apply(rule wp_ir_pr_conj_elim1)  
          apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac "lift\<^sub>1 (not_value T2 n2 0) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 n2 0))")
  apply blast
         apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(subgoal_tac "Reg T1 {reg. reg wr = 0}
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T1 {reg. reg wr = 0})")
        apply blast 
  apply (simp add: act_wp_Reg_stable_other)
          apply(rule wp_ir_pr_disj_intro2)  
          apply(rule wp_ir_pr_conj_intro)  
          apply(rule wp_ir_pr_conj_intro)  
  apply(subgoal_tac "(Reg T2 {reg. reg rr2 = Suc 0}) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T2 {reg. reg rr2 = Suc 0})")
          apply blast 
  using assms(10) load_wp_Reg_other apply blast
  apply(subgoal_tac "(Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
        lift\<^sub>1 (not_value T2 n2 0))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
            lift\<^sub>1 (not_value T2 n2 0))")
         apply blast
        apply(rule wp_ir_pr_disj_elim) 
         apply(rule wp_ir_pr_disj_intro1) 
  using assms(11) load_wp_Reg5 apply blast
          apply(rule wp_ir_pr_disj_intro2) 
       apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)

  apply(subgoal_tac "  (Reg T1 (- {reg. reg mbr = 2}) \<union>
        lift\<^sub>1 (not_value T2 n1 0))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 ra m w r n1 x)
            (T2, Some (load False x ra v))\<rangle>
           (Reg T1 (- {reg. reg mbr = 2}) \<union>
            lift\<^sub>1 (not_value T2 n1 0))")
  apply blast
        apply(rule wp_ir_pr_disj_elim) 
         apply(rule wp_ir_pr_disj_intro1) 
  using assms(11) load_wp_Reg5 apply blast
          apply(rule wp_ir_pr_disj_intro2) 
       apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
     apply(simp add: r_inv_def)
         apply(rule wp_ir_pr_conj_intro) 
         apply(rule wp_ir_pr_conj_intro) 
         apply(rule wp_ir_pr_conj_intro) 
  apply (metis Int_absorb act_wp_Reg_stable_other wp_ir_pr_conj_elim3)
  apply(subgoal_tac "(Reg T2 {reg. reg mbr = mb}) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T2 {reg. reg mbr = mb})")
  apply blast  
  apply (metis assms(13) load_wp_Reg_other)
         apply(rule wp_ir_pr_conj_intro) 
         apply(rule wp_ir_pr_conj_intro) 
         apply(rule wp_ir_pr_conj_intro) 
         apply(rule wp_ir_pr_conj_intro) 
         apply(rule wp_ir_pr_conj_intro) 
         apply(rule wp_ir_pr_conj_intro) 
            apply(rule wp_ir_pr_conj_intro) 
  apply(subgoal_tac "(lift\<^sub>1 (constrained_value T2 x {0, Suc 0})) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (lift\<^sub>1 (constrained_value T2 x {0, Suc 0}))")
  apply blast
             apply (simp add: constrained_value_stable_load)
  apply(subgoal_tac " (lift\<^sub>1 (constrained_value T2 m {Suc 0, 2}))      \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (lift\<^sub>1 (constrained_value T2 m {Suc 0, 2}))")
             apply blast
            apply (simp add: constrained_value_stable_load)
  apply(subgoal_tac " (lift\<^sub>1
             (\<langle>G (T2, R True x (Suc 0))\<rangle>
               (synced T2 x (Suc 0))))  \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (lift\<^sub>1
             (\<langle>G (T2, R True x (Suc 0))\<rangle>
               (synced T2 x (Suc 0))))")
            apply blast
           apply (simp add: cobs_pres_load)
  apply(subgoal_tac "(lift\<^sub>1
             (\<langle>G (T2, R True x (Suc 0))\<rangle>
               (synced T2 m (Suc (mb mod 2))))) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (lift\<^sub>1
             (\<langle>G (T2, R True x (Suc 0))\<rangle>
               (synced T2 m (Suc (mb mod 2)))))")
           apply blast  
          apply (simp add: cobs_pres_load)
         apply(subgoal_tac "    

       Reg T1 {reg. reg mbr = mb} \<inter>

       Reg T2 {reg. reg mbr = mb} \<inter>

       lift\<^sub>1 (constrained_value T2 x {0, Suc 0}) \<inter>

       lift\<^sub>1(\<langle>G (T2, R True x (Suc 0))\<rangle> (synced T2 x (Suc 0))) \<inter>
       
       lift\<^sub>1(\<langle>G (T2, R True x (Suc 0))\<rangle>(synced T2 m (Suc (mb mod 2)))) \<inter>

       (Reg T2 (- {reg. reg ra = Suc 0}) \<union> lift\<^sub>1 (synced T2 x (Suc 0)))  \<inter>

       ((lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
         Reg T2 {reg. reg ra = Suc 0} \<inter> (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
        (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
            (Reg T2 (- {reg. reg ra = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 x (Suc 0)))")
          apply blast
         apply(case_tac "v = 0")
  apply(rule wp_ir_pr_disj_intro1)  
          apply (simp add: load_wp_Reg3)
         apply(case_tac "v = Suc 0")
          apply(rule wp_ir_pr_disj_intro2) 
  apply(subgoal_tac " 
       lift\<^sub>1 (\<langle>G (T2, R True x (Suc 0))\<rangle> (synced T2 x (Suc 0))) \<inter>
       lift\<^sub>1 (\<langle>G (T2, R True x (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))
       \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter> lift\<^sub>1 (synced T2 x (Suc 0)))")
           apply blast
          apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_elim2)
  apply (simp add: object_read_lifted_wp)
  apply(rule wp_ir_pr_conj_elim1)
          apply (simp add: object_read_lifted_wp)
  apply(subgoal_tac "       lift\<^sub>1 (constrained_value T2 x {0, Suc 0})
\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T2 (- {reg. reg ra = Suc 0}) \<union>
            lift\<^sub>1
             (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 x (Suc 0)))")
  apply blast
  apply(subgoal_tac "
       lift\<^sub>1 (constrained_value T2 x {0, Suc 0})
       \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           ({})")
  using load_wp_empty_q apply blast
         apply (simp add: constrained_value_load_not_in)
  apply(subgoal_tac " ((lift\<^sub>1 (not_value T1 r (Suc 0))) \<union>
            ((Reg T2 (- {reg. reg ra = Suc 0}) \<union>
         lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
         lift\<^sub>1 (synced T2 x (Suc 0))) \<inter> Reg T2 {reg. reg ra = Suc 0}))  \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
            Reg T2 {reg. reg ra = Suc 0})")
         apply blast
  apply(rule wp_ir_pr_disj_elim)
  apply(rule wp_ir_pr_disj_intro1)
         apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply(rule wp_ir_pr_disj_intro2)
   using P_nP_Q_P_Q[where P = "Reg T2 ({reg. reg rr2 = Suc 0})" and 
                    Q = "lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
        lift\<^sub>1 (synced T2 w (Suc 0))"] Reg_not_not_Reg
         apply (simp add: Reg_not_not_Reg)
   apply(subgoal_tac "    
        lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
        lift\<^sub>1 (synced T2 x (Suc 0))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T2 {reg. reg ra = Suc 0})")
          apply blast
   apply(rule wp_ir_pr_conj_elim2)
         apply (metis load_wp_Reg load_wp_synced_value)
   apply(subgoal_tac "(Reg T2 (- {reg. reg a = 0})) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T2 (- {reg. reg a = 0}))")
   apply blast
   using assms(10) load_wp_Reg5 apply blast

   apply(subgoal_tac "(lift\<^sub>1 (not_value T2 n1 0) \<inter>
            lift\<^sub>1 (not_value T2 n2 0) \<inter>
            Reg T1 {reg. reg wr = 0})
             \<union>
            ( (Reg T2 (- {reg. reg ra = Suc 0}) \<union>
         lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
         lift\<^sub>1 (synced T2 x (Suc 0))) \<inter> Reg T2 {reg. reg ra = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union>
             lift\<^sub>1 (not_value T2 n1 0))) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter>
            lift\<^sub>1 (not_value T2 n2 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg ra = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union>
             lift\<^sub>1 (not_value T2 n1 0)))")
   apply blast

   apply(rule wp_ir_pr_disj_elim)
        apply(rule wp_ir_pr_disj_intro1)
     apply(rule wp_ir_pr_conj_intro)
     apply(rule wp_ir_pr_conj_intro)
   apply(rule wp_ir_pr_conj_elim1)
   apply(rule wp_ir_pr_conj_elim1)
  apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
   apply(rule wp_ir_pr_conj_elim1)
   apply(rule wp_ir_pr_conj_elim2)
         apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
        apply(rule wp_ir_pr_conj_elim2)
   apply (simp add: act_wp_Reg_stable_other)
       apply(rule wp_ir_pr_disj_intro2)


   using P_nP_Q_P_Q[where P = "Reg T2 ({reg. reg rr2 = Suc 0})" and 
                    Q = "lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
        lift\<^sub>1 (synced T2 w (Suc 0))"] Reg_not_not_Reg
         apply (simp add: Reg_not_not_Reg)
   apply(subgoal_tac " (
        lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
        lift\<^sub>1 (synced T2 x (Suc 0))) \<inter>
       Reg T2 {reg. reg ra = Suc 0} \<inter>
       (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
        lift\<^sub>1 (not_value T2 n2 0)) \<inter>
       (Reg T1 (- {reg. reg mbr = 2}) \<union>
        lift\<^sub>1 (not_value T2 n1 0))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T2 {reg. reg ra = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union>
             lift\<^sub>1 (not_value T2 n1 0)))
")
   apply blast
       apply(rule wp_ir_pr_conj_intro, rule wp_ir_pr_conj_intro)
   apply(subgoal_tac " lift\<^sub>1 (synced T2 x (Suc 0)) 
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T2 {reg. reg ra = Suc 0})")
   apply blast   
         apply (metis load_wp_Reg load_wp_synced_value)
   apply(subgoal_tac "(Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
            lift\<^sub>1 (not_value T2 n2 0)) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
            lift\<^sub>1 (not_value T2 n2 0))")
         apply blast
        apply(rule wp_ir_pr_disj_elim)
        apply(rule wp_ir_pr_disj_intro1)
   using assms(13) load_wp_Reg5 apply blast
        apply(rule wp_ir_pr_disj_intro2)
        apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
   apply(subgoal_tac " (Reg T1 (- {reg. reg mbr = 2}) \<union>
            lift\<^sub>1 (not_value T2 n1 0))\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T1 (- {reg. reg mbr = 2}) \<union>
            lift\<^sub>1 (not_value T2 n1 0))")
   apply blast
         apply(rule wp_ir_pr_disj_elim)
        apply(rule wp_ir_pr_disj_intro1)
   using assms(13) load_wp_Reg5 apply blast
         apply(rule wp_ir_pr_disj_intro2)
       apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
   apply(subgoal_tac "lift\<^sub>1 (constrained_value T2 x {0, Suc 0})
\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 ra a m x r n1 n2)
            (T2, Some (load True x ra v))\<rangle>
           (Reg T2 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg ra = Suc 0}) ")
       apply blast
  using constrained_value_load_wp [where t=T2 and V="{0,Suc 0}" and r=rr2 and Pr="(rcu mb mbr wr rr1 rr2 a m w r n1 n2)"
    and b="True" and x=w  and Ts="{T1,T2}"]
     apply simp
    defer
  apply(case_tac "t=T1"; case_tac "t=T2"; case_tac pc; simp)
   apply(case_tac "t=T1"; case_tac "t=T2"; case_tac pc; simp)
         apply(simp add: outline_def r_inv_def)
  apply(case_tac pc;case_tac "t = T1";simp)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_intro)
     apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
                apply (simp add: store_wp_Reg_stable)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim2)
     apply (simp add: store_wp_Reg_stable)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_intro)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim2)
  apply(rule wp_ir_pr_conj_elim1)


           apply(subgoal_tac " (lift\<^sub>1 (constrained_value T2 w {0, Suc 0}))
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 a m w x n1 n2)
            (T2, Some (store False x v))\<rangle>
           (lift\<^sub>1 (constrained_value T2 w {0, Suc 0}))")
              apply blast
    using assms  constrained_value_stable  constrained_value_\<beta>_stable interf_wp  
               apply (simp add: object_write_lifted_wp)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim2)
            apply(rule wp_ir_pr_conj_elim1)
            apply(subgoal_tac "  (lift\<^sub>1 (constrained_value T2 m {Suc 0, 2}))\<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 a m w x n1 n2)
            (T2, Some (store False x v))\<rangle>
           (lift\<^sub>1 (constrained_value T2 m {Suc 0, 2}))", blast)
    using assms  constrained_value_stable  constrained_value_\<beta>_stable interf_wp  
              apply (simp add: object_write_lifted_wp)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)

  apply(rule wp_ir_pr_conj_elim2)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
    apply(rule wp_ir_pr_conj_elim2)
    using c_obs_write_diff_var_pres
    apply (smt W_var W_wval assms(19) object_write_lifted_wp)
   apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)

  apply(rule wp_ir_pr_conj_elim2)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
    apply(rule wp_ir_pr_conj_elim2)
    using c_obs_write_diff_var_pres
          apply (smt W_var W_wval assms object_write_lifted_wp)  
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim1)
  apply(rule wp_ir_pr_conj_elim2)
  apply(rule wp_ir_pr_conj_elim1)
    apply(subgoal_tac " (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0))) \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 a m w x n1 n2)
            (T2, Some (store False x v))\<rangle>
           (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
            lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
            lift\<^sub>1 (synced T2 w (Suc 0)))")
          apply blast
         apply(rule wp_ir_pr_disj_elim)
         apply(rule wp_ir_pr_disj_intro1)
    apply (simp add: store_wp_Reg_stable)
          apply(rule wp_ir_pr_disj_intro2)
         apply(rule wp_ir_pr_conj_intro)
    apply(rule wp_ir_pr_conj_elim1)
      using interf_wp synced_value_\<beta>_stable synced_value_stable
            apply (smt W_var assms(18) object_write_lifted_wp)
    apply(rule wp_ir_pr_conj_elim2)
      using interf_wp synced_value_\<beta>_stable synced_value_stable
           apply (smt W_var assms object_write_lifted_wp)


          apply(subgoal_tac "v\<in>{0, Suc 0}")
      apply(subgoal_tac " ( (Reg T2 {reg. reg rr2 = 0} \<union>
        Reg T2 {reg. reg rr2 = Suc 0})  \<inter>   Reg T2 {rf. e rf = v} \<inter>  lift\<^sub>1 (not_value T1 x (Suc 0))) \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 a m w x n1 n2)
            (T2, Some (store False x v))\<rangle>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union>
            Reg T2 {reg. reg rr2 = Suc 0})")
           apply blast \<comment> \<open>very slow\<close>
          apply(rule wp_ir_pr_disj_elim)
            apply(case_tac "v = 0")
             apply(rule wp_ir_pr_disj_intro1)
      apply(rule wp_ir_pr_conj_elim2)
      using assms no_value_stable_diff_var_store    
      apply (simp add: assms(10) assms(11) assms(12) assms(13) assms(14) assms(15) assms(16) assms(17) assms(18) assms(19) no_value_stable_diff_var_store)
            apply simp
      apply(subgoal_tac "(Reg T2 {reg. reg rr2 = 0} \<union>
        Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
       Reg T2 {rf. e rf = Suc 0} =  Reg T2 {reg. reg rr2 = Suc 0}")
      apply(subgoal_tac " 
        Reg T2 {reg. reg rr2 = Suc 0}
       \<subseteq> \<langle>full_step {T1, T2}
            (rcu mb mbr wr rr1 rr2 a m w x n1 n2)
            (T2, Some (store False x (Suc 0)))\<rangle>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union>
            Reg T2 {reg. reg rr2 = Suc 0})")
              apply blast
      apply(rule wp_ir_pr_disj_intro2)
             apply (simp add: store_wp_Reg_stable)
     apply blast
      apply(rule wp_ir_pr_disj_intro2)
           apply (simp add: store_wp_Reg_stable)
             apply(subgoal_tac " (Reg T2 {reg. reg rr2 = 0} \<union>
        Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
       Reg T2 {rf. e rf = v} \<noteq>
       {}")
            apply(simp add:Reg_def lift_t_def lift\<^sub>2_def)
      apply auto[1]
          apply blast
 
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim2)
      apply(rule wp_ir_pr_conj_elim1)
         apply(rule wp_ir_pr_conj_elim2)
      apply (simp add: store_wp_Reg_stable)
        apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim2)
      apply(rule wp_ir_pr_conj_elim2)
        apply(rule wp_ir_pr_disj_elim)
         apply(rule wp_ir_pr_disj_intro1)
         apply(rule wp_ir_pr_conj_intro)
         apply(rule wp_ir_pr_conj_intro)
         apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
   apply (metis (no_types, hide_lams) assms(20)  no_value_stable_diff_var_store)
         apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim2)
   apply (metis (no_types, hide_lams) assms(21)  no_value_stable_diff_var_store)
      apply(rule wp_ir_pr_conj_elim2)
         apply (meson store_wp_Reg_stable) 
           apply(rule wp_ir_pr_disj_intro2)
         apply(rule wp_ir_pr_conj_intro)
         apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_elim1)
          apply(rule wp_ir_pr_conj_elim1)
         apply (meson store_wp_Reg_stable) 
          apply(rule wp_ir_pr_conj_elim1)
          apply(rule wp_ir_pr_conj_elim2)
         apply(rule wp_ir_pr_disj_elim)
          apply(rule wp_ir_pr_disj_intro1)
      apply (meson store_wp_Reg_stable)
          apply(rule wp_ir_pr_disj_intro2)
   apply (metis (no_types, hide_lams) assms insert_Collect insert_compr no_value_stable_diff_var_store)
          apply(rule wp_ir_pr_conj_elim2)
         apply(rule wp_ir_pr_disj_elim)
          apply(rule wp_ir_pr_disj_intro1)
         apply (meson store_wp_Reg_stable)
                  apply(rule wp_ir_pr_disj_intro2)
        apply (metis (no_types, hide_lams) assms insert_Collect insert_compr no_value_stable_diff_var_store)
          apply(rule wp_ir_pr_conj_elim1)
       apply(rule wp_ir_pr_conj_elim2)
           apply(rule wp_ir_pr_disj_elim)
          apply(rule wp_ir_pr_disj_intro1)
        apply (meson store_wp_Reg_stable) 
       apply(rule wp_ir_pr_disj_intro2)
       apply (meson store_wp_Reg_stable)
               apply(simp add: outline_def r_inv_def)
       apply(case_tac pc; case_tac "t = T1"; case_tac "t = T2";simp)
       apply(simp add: outline_def r_inv_def)
      apply(case_tac pc;case_tac "t = T1";simp)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_intro)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
                      apply(rule wp_ir_pr_conj_elim1)
      
      apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
        apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
                     apply(rule wp_ir_pr_conj_elim1)
                     apply(rule wp_ir_pr_conj_elim1)

      apply (simp add: le_infI2 store_wp_Reg_stable)
            apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
                    apply(rule wp_ir_pr_conj_elim1)
                    apply(rule wp_ir_pr_conj_elim2)
      apply (smt Suc_1 T1_def T2_def W_var assms(17) assms(3) insertE insert_commute interf_wp mod2_Suc_Suc mod_Suc mod_Suc_Suc_eq mod_Suc_eq mod_self numeral_1_eq_Suc_0 numeral_eq_one_iff object_write_lifted_wp one_mod_two_eq_one singletonD synced_value_\<beta>_stable synced_value_stable)
              apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
                   apply(rule wp_ir_pr_conj_elim2)
                   apply (metis assms(17) no_value_stable_diff_var_store)
      apply(rule wp_ir_pr_conj_elim1)
      apply(rule wp_ir_pr_conj_elim1)
                  apply(rule wp_ir_pr_conj_elim2)
      using synced_value_self_write 
      apply (simp add: object_write_lifted_wp)
                 apply(rule wp_ir_pr_conj_elim2)
      using constrained_value_stable_store_diff_var
      apply (metis assms(18))
      apply auto[1]
               apply(rule wp_ir_pr_conj_intro)
                 apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_elim1)
          apply(rule wp_ir_pr_conj_elim1)
          apply(rule wp_ir_pr_conj_elim1)
          apply(rule wp_ir_pr_conj_elim1)
                  apply(rule wp_ir_pr_conj_elim1)
                  apply (simp add: store_wp_Reg_stable)
         apply(rule wp_ir_pr_conj_elim1)
          apply(rule wp_ir_pr_conj_elim1)
          apply(rule wp_ir_pr_conj_elim1)
                 apply(rule wp_ir_pr_conj_elim1)  
                 apply(rule wp_ir_pr_conj_elim2)
                        apply (simp add: store_wp_Reg_stable)
                 apply(rule wp_ir_pr_conj_elim2)
      using constrained_value_stable_store_diff_var  apply (metis assms(19))
      apply auto[4]
                      apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_elim1) 
      apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
          apply(rule wp_ir_pr_conj_elim1) 
          apply(rule wp_ir_pr_conj_elim1) 
          apply(rule wp_ir_pr_conj_elim2) 
            apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
      apply auto[1]
                      apply(rule wp_ir_pr_conj_intro)
          apply(rule wp_ir_pr_conj_elim1) 
      apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
          apply(rule wp_ir_pr_conj_elim1) 
          apply(rule wp_ir_pr_conj_elim1) 
          apply(rule wp_ir_pr_conj_elim2) 
            apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
      by auto[2]


lemma not_synced_simp:
  shows "lift\<^sub>1 (not_value t x v) \<inter> lift\<^sub>1 (synced t x v) \<subseteq>  {}"
  by (meson lift\<^sub>1_inter_empty_mono not_value_synced_empty)



lemma 
  assumes "A \<subseteq> B"
  shows "A \<inter> P \<subseteq> -P \<union> B"
  by (simp add: assms le_infI1 le_supI1 sup_commute)



lemma reg_stable_to_neg:
  assumes "x \<noteq> y" and "v \<noteq> v'"
  shows   "Reg t {reg. reg x = v}
           \<subseteq> \<langle>full_step Ts
               Pr
               (t, Some (store b y w))\<rangle>
               (Reg t (- {reg. reg x = v'}))"
  by (metis (mono_tags, lifting) Collect_mono Collect_neg_eq Reg_mono assms(2) interpolation_left store_wp_Reg_stable)

lemma reg_contra:
  assumes "v \<noteq> v'" 
  shows "Reg t {reg. reg r = v} \<inter> Reg t {reg. reg r = v'}  \<subseteq> {}"
  using assms apply(simp add: Reg_def lift\<^sub>2_def lift_t_def)
  by auto

lemma reg_contra_P:
  assumes "v \<noteq> v'"
  shows "Reg t {reg. reg r = v} \<inter> Reg t {reg. reg r = v'} \<inter> P \<subseteq> {}"
  using assms apply(simp add: Reg_def lift\<^sub>2_def lift_t_def)
  by auto


lemma reg_contra_Q:
  assumes "v \<noteq> v'"
  shows "Reg t {reg. reg r = v} \<inter> Reg t {reg. reg r = v'} \<union> Q \<subseteq> Q"
  using assms apply(simp add: Reg_def lift\<^sub>2_def lift_t_def)
  by auto

lemma reg_contra_P_Q:
  assumes "v \<noteq> v'"
  shows "(Reg t {reg. reg r = v} \<inter> Reg t {reg. reg r = v'} \<inter> P) \<union> Q \<subseteq> Q"
  using assms apply(simp add: Reg_def lift\<^sub>2_def lift_t_def)
  by auto


lemma store_hc_1: 
  assumes "x \<noteq> wr" and "x \<noteq> mbr" and "x \<noteq> n''" and "x \<noteq> rr''" 
  shows "Reg T1 {reg. reg wr = Suc 0} \<inter>
           Reg T1 {reg. reg mbr = Suc 0} \<inter>
           (lift\<^sub>1 (not_value T2 x 0) \<inter>
            lift\<^sub>1 (not_value T2 n'' 0) \<inter>
            Reg T1 {reg. reg wr = 0} \<union>
            Reg T2 {reg. reg rr'' = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
             lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union>
             lift\<^sub>1 (not_value T2 x 0)))
           \<subseteq> \<langle>full_step {T1, T2}
               (rcu mb mbr wr rr' rr'' a m w r x n'')
               (T1, Some (store False x 0))\<rangle>
               (lift\<^sub>1 (not_value T2 x 0) \<inter>
                lift\<^sub>1 (not_value T2 n'' 0) \<inter>
                Reg T1 {reg. reg wr = 0} \<union>
                Reg T2 {reg. reg rr'' = Suc 0} \<inter>
                (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
                 lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
                (Reg T1 (- {reg. reg mbr = 2}) \<union>
                 lift\<^sub>1 (not_value T2 x 0)))"
   apply (rule subset_trans[where B="(Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg wr = 0}) \<union>
            (Reg T1 {reg. reg mbr = Suc 0} \<inter>
             (Reg T2 {reg. reg rr'' = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 x 0))))"], blast)
   apply (rule subset_trans[where B=" (Reg T1 {reg. reg mbr = Suc 0} \<inter>
             (Reg T2 {reg. reg rr'' = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 x 0))))"])
  using reg_contra_Q[where t="T1" and r="wr" and v=1 and v'=0 and Q="(Reg T1 {reg. reg mbr = Suc 0} \<inter>
             (Reg T2 {reg. reg rr'' = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 x 0))))"] 
  apply simp
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using T_neq act_wp_Reg_stable_other apply blast

  apply (smt One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff Un_upper2 \<open>1 \<noteq> 0 \<Longrightarrow> Reg T1 {reg. reg wr = 1} \<inter> Reg T1 {reg. reg wr = 0} \<union> Reg T1 {reg. reg mbr = Suc 0} \<inter> (Reg T2 {reg. reg rr'' = Suc 0} \<inter> (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n'' 0)) \<inter> (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))) \<subseteq> Reg T1 {reg. reg mbr = Suc 0} \<inter> (Reg T2 {reg. reg rr'' = Suc 0} \<inter> (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n'' 0)) \<inter> (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0)))\<close> assms(3) inf.absorb_iff2 inf_commute inf_idem inf_left_commute no_value_stable_diff_var_store store_wp_Reg_stable subset_antisym subset_trans wp_ir_pr_disj_elim wp_pred_sup_semi_distrib)
  
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_disj_intro1)
  by (metis One_nat_def T1_def T2_def T_neq assms(2) reg_stable_to_neg)

lemma store_hc_2:
  assumes "x \<noteq> wr" and "x \<noteq> mbr" and "x \<noteq> n'" and "x \<noteq> rr''" 

  shows "Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
    (lift\<^sub>1 (not_value T2 n' 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
     Reg T1 {reg. reg wr = 0} \<union>
     Reg T2 {reg. reg rr2 = Suc 0} \<inter>
     (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
     (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0)))
    \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n' x)
        (T1, Some (store False x 0))\<rangle>
        (lift\<^sub>1 (not_value T2 n' 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
         Reg T1 {reg. reg wr = 0} \<union>
         Reg T2 {reg. reg rr2 = Suc 0} \<inter>
         (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
         (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0)))"

  apply (rule subset_trans[where B="(Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg wr = 0}) \<union>
            (Reg T1 {reg. reg mbr = 2} \<inter>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0)))"], blast)
  apply (rule subset_trans[where B=" (Reg T1 {reg. reg mbr = 2} \<inter>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0)))"])
  using reg_contra_Q[where t="T1" and r="wr" and v=1 and v'=0 and Q="(Reg T1 {reg. reg mbr = 2} \<inter>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0)))"] 
  apply (smt Collect_cong One_nat_def Suc_1 T1_def T2_def T_neq)  
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using T_neq act_wp_Reg_stable_other apply blast
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_disj_intro1)
  apply (metis One_nat_def T1_def T2_def T_neq assms(2) reg_stable_to_neg)
  apply (rule subset_trans[where B="Reg T1 (- {reg. reg mbr = 2}) \<union>
                lift\<^sub>1 (not_value T2 n' 0)"], blast)
  by (meson assms(3) interpolation_left no_value_stable_diff_var_store store_wp_Reg_stable sup.mono wp_pred_sup_semi_distrib)


(*
    Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
    (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
     Reg T1 {reg. reg wr = 0} \<union>
     Reg T2 {reg. reg rr2 = Suc 0} \<inter>
     (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
     (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))
    \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 x)
        (T1, Some (store False x 0))\<rangle>
        (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
         Reg T1 {reg. reg wr = 0} \<union>
         Reg T2 {reg. reg rr2 = Suc 0} \<inter>
         (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
         (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))
*)
(*
 \<And>t' pc b e x v pc' pc''.
       t' \<in> {T1, T2} \<Longrightarrow>
       t' \<noteq> t \<Longrightarrow>
       rcu mb mbr wr rr1 rr2 a m w r n1 n2 t' pc' = storee b x e pc'' \<Longrightarrow>
       outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc \<inter>
       outline mb mbr wr rr1 rr2 a m w r n1 n2 t' pc' \<inter>
       Reg t' {rf. e rf = v}
       \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 n2)
           (t', Some (store b x v))\<rangle>
           (outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc)
*)

lemma constrained_val_stable:
"lift\<^sub>1 (constrained_value t x {m, n})
           \<subseteq> \<langle>full_step Ts Pr
               (t', Some (store b x m))\<rangle>
               (lift\<^sub>1 (constrained_value t x {m, n}))"
  by (simp add: constrained_value_\<beta>_stable constrained_value_stable interf_wp object_write_lifted_wp)


lemma NI_storee:
  assumes
       "d \<noteq> f"
  and "rr1 \<noteq> rr2"
  and "mb\<in>{1,2}"
  and "a \<noteq> rr1"
  and "m \<noteq> n1"
  and "m \<noteq> n2"
  and "n1 \<noteq> n2"
  and "wr \<noteq> rr1"
  and "a \<noteq> rr1"
  and "a \<noteq> rr2"
  and "mbr \<noteq> a"
  and "mbr \<noteq> rr1"
  and "mbr \<noteq> rr2"
  and "mbr \<noteq> wr"
  and "wr \<noteq> r"
  and "r \<noteq> w"
  and "r \<noteq> m"
  and "m \<noteq> w"
  and "w \<noteq> n1"
  and "w \<noteq> n2"
  and "n1 \<noteq> w"
  and "n1 \<noteq> mbr"
  and "n2 \<noteq> mbr"
  and "n1 \<noteq> rr2"
  and "n2 \<noteq> rr2"
  and "n1 \<noteq> rr1"
  and "n2 \<noteq> rr1"
  and "n1 \<noteq> wr"
  and "n2 \<noteq> wr"
  and a1: "t' \<in> {T1, T2}"
  and a2: "t' \<noteq> t"
  and a3: "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t' pc' = storee b x e pc''"
  shows "outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc \<inter>
       outline mb mbr wr rr1 rr2 a m w r n1 n2 t' pc' \<inter>
       Reg t' {rf. e rf = v}
       \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 n2)
           (t', Some (store b x v))\<rangle>
           (outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc)"
   using a1 a2 a3 apply(simp add: outline_def)
   apply(case_tac "t=T1", simp_all)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
   apply (simp add: le_infI1 store_wp_Reg_stable)
   using store_wp_Reg_stable apply force
   apply (rule subset_trans [where B="lift\<^sub>1 (synced T1 w 0)"],blast)
   apply (metis (no_types, lifting) W_var assms(16) interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
   apply (smt assms(16) inf.cobounded2 no_value_stable_diff_var_store subset_trans wp_ir_pr_conj_elim3)
   apply (rule basic_wp_pres) 
   apply (metis (no_types, lifting) W_var assms(17) interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
   apply blast  
   apply (rule basic_wp_pres) 
   apply (metis (no_types, lifting) W_var assms(17) interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
   apply blast  
     defer
   using store_wp_Reg_stable apply force
   apply (rule basic_wp_pres) 
   apply (simp add: store_wp_Reg_stable)
   apply blast
   apply (rule basic_wp_pres) 
   apply (metis (no_types, lifting) W_var assms(16) interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
   apply blast
   apply (rule basic_wp_pres) 
   using assms(16) no_value_stable_diff_var_store apply blast
   apply blast
   apply (rule basic_wp_pres) 
   apply (metis (no_types, lifting) W_var assms(17) interf_wp2 object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
   apply blast
   defer
   apply (rule basic_wp_pres, simp add: store_wp_Reg_stable, blast)+
   defer
   apply (rule basic_wp_pres, simp add: store_wp_Reg_stable, blast)+
   defer
   apply (rule basic_wp_pres, simp add: store_wp_Reg_stable, blast)+
   apply (intro impI conjI)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)

      apply (rule subset_trans [where B="
     (Reg T2 {reg. reg rr2 = 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v}) \<union>
     (Reg T2 {reg. reg rr2 = Suc 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v})"],blast)
      apply(rule wp_ir_pr_disj_elim)
   apply(case_tac "v = 0") 
   using constrained_val_stable apply blast
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
   apply blast
   apply(case_tac "v = Suc 0") 
   using constrained_val_stable
   apply (smt inf.coboundedI2 inf_commute insert_commute)
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
      apply blast

      apply (rule subset_trans [where B="
     (Reg T2 {reg. reg rr2 = 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v}) \<union>
     (Reg T2 {reg. reg rr2 = Suc 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v})"],blast)
      apply(rule wp_ir_pr_disj_elim)
   apply(case_tac "v = 0") 
   using constrained_val_stable apply blast
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
   apply blast
   apply(case_tac "v = Suc 0") 
   using constrained_val_stable
   apply (smt inf.coboundedI2 inf_commute insert_commute)
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
     apply blast


      apply (rule subset_trans [where B="
     (Reg T2 {reg. reg rr2 = 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v}) \<union>
     (Reg T2 {reg. reg rr2 = Suc 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v})"],blast)
      apply(rule wp_ir_pr_disj_elim)
   apply(case_tac "v = 0") 
   using constrained_val_stable apply blast
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
   apply blast
   apply(case_tac "v = Suc 0") 
   using constrained_val_stable
   apply (smt inf.coboundedI2 inf_commute insert_commute)
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
    apply blast


      apply (rule subset_trans [where B="
     (Reg T2 {reg. reg rr2 = 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v}) \<union>
     (Reg T2 {reg. reg rr2 = Suc 0} \<inter> lift\<^sub>1(constrained_value T1 x {0, Suc 0}) \<inter> Reg T2 {rf. e rf = v})"],blast)
      apply(rule wp_ir_pr_disj_elim)
   apply(case_tac "v = 0") 
   using constrained_val_stable apply blast
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
   apply blast
   apply(case_tac "v = Suc 0") 
   using constrained_val_stable
   apply (smt inf.coboundedI2 inf_commute insert_commute)
       apply(rule subset_trans[where B = "{}"])
        apply(fastforce simp add: Reg_def lift\<^sub>1_def lift_t_def lift\<^sub>2_def)
   by blast

lemma NI_store:
  assumes
       "d \<noteq> f"
  and "rr1 \<noteq> rr2"
  and "mb\<in>{1,2}"
  and "a \<noteq> rr1"
  and "m \<noteq> n1"
  and "m \<noteq> n2"
  and "n1 \<noteq> n2"
  and "wr \<noteq> rr1"
  and "a \<noteq> rr1"
  and "a \<noteq> rr2"
  and "mbr \<noteq> a"
  and "mbr \<noteq> rr1"
  and "mbr \<noteq> rr2"
  and "mbr \<noteq> wr"
  and "wr \<noteq> r"
  and "r \<noteq> w"
  and "r \<noteq> m"
  and "m \<noteq> w"
  and "w \<noteq> n1"
  and "w \<noteq> n2"
  and "n1 \<noteq> w"
  and "n1 \<noteq> mbr"
  and "n2 \<noteq> mbr"
  and "n1 \<noteq> rr2"
  and "n2 \<noteq> rr2"
  and "n1 \<noteq> rr1"
  and "n2 \<noteq> rr1"
  and "n1 \<noteq> wr"
  and "n2 \<noteq> wr"
  and a1: "t' \<in> {T1, T2}"
  and a2: "t' \<noteq> t"
  and a3: "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t' pc' =
       storec b x v pc''"
  shows "outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc \<inter>
       outline mb mbr wr rr1 rr2 a m w r n1 n2 t' pc'
       \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 n2)
           (t', Some (store b x v))\<rangle>
           (outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc)"
   using a1 a2 a3 apply(simp add: outline_def)
   apply(case_tac "t=T1", simp_all)
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
   apply (intro impI conjI)
  apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
  apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
  apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)

  (* L1 L1 *)
  apply (simp add: le_infI1 store_wp_Reg_stable)
  using store_wp_Reg_stable apply fastforce
  apply (simp_all add: r_inv_def)
  apply (rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1)
   apply (rule basic_wp_pres) 
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply blast
  using assms(3) apply (case_tac "m=1", simp)
  apply (rule basic_wp_pres) 
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply blast
                      apply (rule basic_wp_pres) 
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply blast
  apply (rule basic_wp_pres) 
  apply (metis W_var assms(17) interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply blast
  (* cond value *)
  apply (rule basic_wp_pres) 
  apply (metis W_var assms(18) c_obs_write_diff_var_pres object_write_lifted_wp, blast)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"],blast)
  apply (metis W_var assms(18) inf.coboundedI1 object_write_lifted_wp transfer_wr_diff_var_pres)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<union> lift\<^sub>1 (synced T1 w (Suc 0))"], blast)   
  apply (smt Un_subset_iff W_var assms(18) interf_wp no_value_stable_diff_var_store object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)    
  apply (smt bool_alg_inf1 inf.absorb_iff2 inf_left_commute store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (meson dual_order.trans inf_le2 le_infI1 store_wp_Reg_stable)
  apply (smt assms(5) inf.cobounded2 no_value_stable_diff_var_store subset_trans wp_ir_pr_conj_elim3)
  apply (smt assms(6) inf.coboundedI1 inf_commute no_value_stable_diff_var_store)

  (* L2 L1 *)
  apply (meson le_infI1 store_wp_Reg_stable)
  using a2 act_wp_Reg_stable_other apply blast
                      apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 x {0, v})"], blast)   
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {v, 2})"], blast)   
  apply (simp add: constrained_value_\<beta>_stable constrained_value_stable interf_wp object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 r 0)"], blast)   
  apply (metis W_var assms(16) interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  (* cond value *)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)


  using assms(18) lifted_transfer_intro apply blast
  apply simp
                      apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0)"], blast)
  apply (rule wp_ir_pr_disj_intro2)
  apply (simp add: object_write_lifted_wp synced_value_self_write)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
  using store_wp_Reg_stable apply force
  apply (meson dual_order.trans inf.cobounded2 le_infI1 store_wp_Reg_stable)
  apply (smt assms(19) inf.absorb_iff2 no_value_stable_diff_var_store wp_ir_pr_conj_elim3 wp_ir_pr_conj_elim5)
  apply (smt assms(20) inf.coboundedI1 inf_commute no_value_stable_diff_var_store)

  (* L6 L1 *)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf_le2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast) 
  apply (simp add: constrained_value_\<beta>_stable constrained_value_stable interf_wp object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast) 
  apply (metis W_var assms(5) constrained_value_\<beta>_stable constrained_value_stable interf_wp object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 r 0)"], blast) 
  apply (simp add: interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg wr = 0}"],blast)
  apply (metis empty_subsetI not_mod2_eq_Suc_0_eq_0 reg_contra subset_empty)
  apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 w (Suc 0)) \<union> lift\<^sub>1 (synced T1 w (Suc 0)))"], blast)
  apply (smt Un_subset_iff W_var assms(19) interf_wp no_value_stable_diff_var_store object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt bool_alg_inf1 inf.absorb_iff2 inf_left_commute store_wp_Reg_stable)
  apply (meson inf_le2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (meson inf_le2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (meson dual_order.trans inf.cobounded2 le_infI1 store_wp_Reg_stable)
  apply (rule subset_trans[where B="{}"])
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = 0} \<inter> Reg T1 {reg. reg wr = Suc 0}"], blast)
  apply (metis One_nat_def Suc_1 T1_def T2_def T_neq reg_contra)
  apply blast
  using assms(7) no_value_stable_diff_var_store apply fastforce

  (* L7 L1 *)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  using T_neq act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 r 0)"], blast)
  apply (simp add: interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  (* cond value *)
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg wr = 0}"],blast)
  apply (metis empty_subsetI not_mod2_eq_Suc_0_eq_0 reg_contra subset_empty)
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg wr = 0}"],blast)
  apply (metis empty_subsetI not_mod2_eq_Suc_0_eq_0 reg_contra subset_empty)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<union> lift\<^sub>1 (synced T1 w (Suc 0))"], blast)
  apply (smt Un_subset_iff W_var assms(20) interf_wp no_value_stable_diff_var_store object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  using T_neq act_wp_Reg_stable_other apply blast
  using T_neq act_wp_Reg_stable_other apply blast
  using store_wp_Reg_stable apply force
  using T_neq act_wp_Reg_stable_other apply blast
  apply (smt assms(7) inf.absorb_iff2 no_value_stable_diff_var_store wp_ir_pr_conj_elim3 wp_ir_pr_conj_elim5)
  apply (rule subset_trans[where B="{}"])
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = 0} \<inter> Reg T1 {reg. reg wr = Suc 0}"], blast)
  apply (metis One_nat_def Suc_1 T1_def T2_def T_neq reg_contra)  
  apply blast

  (*L1 L2*)
  apply (simp add: le_infI1 store_wp_Reg_stable)
  apply (smt inf.absorb_iff2 inf_commute store_wp_Reg_stable wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(18) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"],blast)
  apply (metis W_var assms(18) le_infI1 object_write_lifted_wp transfer_wr_diff_var_pres)

  (* ASK SIMON *)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0})"])
  using not_synced_simp apply fastforce
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(17) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (smt bool_alg_inf1 inf.absorb_iff2 inf_left_commute store_wp_Reg_stable)  
  apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)
  apply (smt RWVarsActions.store_wp_Reg_stable RWVarsActions_axioms Zero_not_Suc inf.absorb_iff2 no_value_stable_diff_var_store wp_ir_pr_conj_elim3 wp_ir_pr_conj_elim4 wp_ir_pr_disj_elim wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pres_absorb)
  apply (rule wp_ir_pr_conj_elim2)
  apply (simp add: no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)

  (* L2 L2 *)
  apply (meson le_infI1 store_wp_Reg_stable)
  apply (smt inf.absorb_iff2 inf_commute store_wp_Reg_stable wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(18) constrained_value_stable_store_diff_var)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)


  using assms(18) lifted_transfer_intro apply blast
  apply simp
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0})"])
  using not_synced_simp apply fastforce
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r v) \<union> Reg T2 {reg. reg rr2 = v}"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(16) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (smt bool_alg_inf1 inf.absorb_iff2 inf_left_commute store_wp_Reg_stable)
  apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (smt Collect_cong One_nat_def Un_subset_iff inf.coboundedI1 no_value_stable_diff_var_store numerals(1) store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib zero_neq_numeral)
  apply (rule subset_trans[where B="Reg T1 (- {reg. reg mbr = 2}) \<union>
                lift\<^sub>1 (not_value T2 n1 0)"], blast)
  apply (smt One_nat_def Un_subset_iff inf.cobounded2 no_value_stable_diff_var_store numerals(1) store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib zero_neq_numeral)

  (* L6 L2 *)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  using T_neq act_wp_Reg_stable_other apply blast
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(21) constrained_value_stable_store_diff_var apply blast  
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(5) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(19) assms(5) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="(Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
          lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
           lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2)+
  apply (rule wp_ir_pr_conj_intro)+
  apply (metis W_var assms(5) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(19) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (meson Suc_neq_Zero Un_mono no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = Suc 0} \<inter>
                ((lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
                 (Reg T2 {reg. reg rr2 = Suc 0} \<inter> 
                   (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
                   (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))))"],blast)
  using store_hc_1 assms(22) assms(24) assms(28) assms(7) apply auto[1]


(* L7 L2 *)
  apply (smt Un_subset_iff assms(7) inf.absorb_iff2 inf_commute inf_left_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_pred_sup_semi_distrib)
  apply (smt inf.absorb_iff2 inf.coboundedI1 inf_left_commute store_wp_Reg_stable)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(20) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(20) assms(6) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="(Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
          lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
           lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2)+
  apply (rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(6) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(20) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (meson Suc_neq_Zero Un_mono dual_order.trans no_value_stable_diff_var_store store_wp_Reg_stable wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
                (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"],blast)
  using store_hc_2 assms(23) assms(29) assms(7) apply auto[1]

  (* L1 L3*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson le_infI1 store_wp_Reg_stable)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply simp
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"], blast)
  apply (metis W_var assms(18) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"],blast)
  apply (metis W_var assms(18) inf.coboundedI1 object_write_lifted_wp transfer_wr_diff_var_pres)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (smt Int_Un_distrib RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_bot_right inf_commute inf_left_commute not_synced_simp wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0})"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(17) inf.absorb_iff2 inf.coboundedI1 no_value_stable_diff_var_store wp_pred_sup_semi_distrib)
                      apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
                      apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
                      apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (smt Un_subset_iff Zero_not_Suc inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (smt Un_subset_iff Zero_not_Suc inf_le2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (rule subset_trans [where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                Reg T2 {reg. reg rr1 = v}"], blast)
  apply (meson Un_subset_iff store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
    apply (meson le_infI1 store_wp_Reg_stable)
  apply (smt inf.absorb_iff2 inf_commute store_wp_Reg_stable wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(18) constrained_value_stable_store_diff_var)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)


  using assms(18) lifted_transfer_intro apply blast
  apply simp
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0})"])
  using not_synced_simp apply fastforce
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r v) \<union> Reg T2 {reg. reg rr2 = v}"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(16) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (smt bool_alg_inf1 inf.absorb_iff2 inf_left_commute store_wp_Reg_stable)
  apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (smt Collect_cong One_nat_def Un_subset_iff inf.coboundedI1 no_value_stable_diff_var_store numerals(1) store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib zero_neq_numeral)
  apply (rule subset_trans[where B="Reg T1 (- {reg. reg mbr = 2}) \<union>
                lift\<^sub>1 (not_value T2 n1 0)"], blast)
  apply (smt One_nat_def Un_subset_iff inf.cobounded2 no_value_stable_diff_var_store numerals(1) store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib zero_neq_numeral)
  apply (smt Un_subset_iff le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
 
  (* L6 L3 *)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  using T_neq act_wp_Reg_stable_other apply blast
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(21) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(5) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(19) assms(5) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="(Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
          lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
           lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2)+
  apply (rule wp_ir_pr_conj_intro)+
  apply (metis W_var assms(5) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(19) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (meson Suc_neq_Zero Un_mono no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = Suc 0} \<inter>
                ((lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
                 (Reg T2 {reg. reg rr2 = Suc 0} \<inter> 
                   (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
                   (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))))"],blast)
  using store_hc_1 assms(22) assms(24) assms(28) assms(7) apply auto[1]
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 inf.cobounded2 inf.coboundedI1 wp_pred_sup_semi_distrib)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)

  (* L7 L3 *)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (smt bool_alg_inf1 inf.absorb_iff2 inf_left_commute store_wp_Reg_stable)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(20) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(20) assms(6) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="(Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
          lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
           lift\<^sub>1 (synced T2 w (Suc 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2)+
  apply (rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(6) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(20) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (meson Suc_neq_Zero Un_mono dual_order.trans no_value_stable_diff_var_store store_wp_Reg_stable wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
  apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
                (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"],blast)
  apply (rule subset_trans[where B="(Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg wr = 0}) \<union>
            (Reg T1 {reg. reg mbr = 2} \<inter>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule subset_trans[where B=" (Reg T1 {reg. reg mbr = 2} \<inter>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
  using reg_contra_Q[where t="T1" and r="wr" and v=1 and v'=0 and Q="(Reg T1 {reg. reg mbr = 2} \<inter>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"] 
  apply (smt Collect_cong One_nat_def Suc_1 T1_def T2_def T_neq)  
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using T_neq act_wp_Reg_stable_other apply blast
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_disj_intro1)
  apply (metis One_nat_def T1_def T2_def T_neq assms(23) reg_stable_to_neg)             
  apply (rule subset_trans[where B="Reg T1 (- {reg. reg mbr = 2}) \<union>
                lift\<^sub>1 (not_value T2 n1 0)"], blast)
  apply (smt RWVarsActions.store_wp_Reg_stable RWVarsActions_axioms Un_subset_iff assms(7) no_value_stable_diff_var_store wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (meson le_infI1 store_wp_Reg_stable)
  apply (smt Un_subset_iff le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)

  (* L1 L4 *)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"],blast)
  apply (metis W_var assms(18) inf.coboundedI1 object_write_lifted_wp transfer_wr_diff_var_pres)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"],blast)
  apply (metis W_var assms(18) inf.coboundedI1 object_write_lifted_wp transfer_wr_diff_var_pres)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(17) inf.absorb_iff2 inf.coboundedI1 no_value_stable_diff_var_store wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Un_subset_iff Zero_not_Suc inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (smt Un_subset_iff Zero_not_Suc inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (*L2 L4*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(18) constrained_value_stable_store_diff_var)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)


  using assms(18) lifted_transfer_intro apply blast
  apply simp
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt Collect_cong RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(16) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Collect_cong One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (rule wp_ir_pr_conj_elim2)
  apply (smt One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (* L6 L4*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(21) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(5) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(19) assms(5) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(5) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(21) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = Suc 0} \<inter>
                ((lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
                 (Reg T2 {reg. reg rr2 = Suc 0} \<inter> 
                   (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
                   (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))))"],blast)
  using store_hc_1 assms(22) assms(24) assms(28) assms(7) apply auto[1]
  apply (smt Un_subset_iff le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)

  (*L7 L4*)
  apply (simp add: le_infI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(20) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(20) assms(6) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(6) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(20) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
                (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"],blast)
  using store_hc_2 assms(23) assms(29) assms(7) apply auto[1]
   apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                Reg T2 {reg. reg rr1 = Suc (mb mod 2)}"], blast)
  apply (simp add: act_wp_Reg_stable_other wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)

  (*L1 L5*)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(18) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"],blast)
  apply (metis W_var assms(18) le_infI1 object_write_lifted_wp transfer_wr_diff_var_pres)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(17) inf.absorb_iff2 inf.coboundedI1 no_value_stable_diff_var_store wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Un_subset_iff Zero_not_Suc inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (smt Un_subset_iff Zero_not_Suc inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (* L2 L5 *)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(18) constrained_value_stable_store_diff_var)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)


  using assms(18) lifted_transfer_intro apply blast
  apply simp
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt Collect_cong RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(16) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Collect_cong One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (rule wp_ir_pr_conj_elim2)
  apply (smt One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (* L6 L5 *)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(21) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(5) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(19) assms(5) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(5) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(21) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = Suc 0} \<inter>
                ((lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
                 (Reg T2 {reg. reg rr2 = Suc 0} \<inter> 
                   (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
                   (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))))"],blast)
  using store_hc_1 assms(22) assms(24) assms(28) assms(7) apply auto[1]
  apply (smt Un_subset_iff le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)

  (*L7 L5*)
  apply (simp add: le_infI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(20) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(20) assms(6) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(6) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(20) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
                (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"],blast)
  using store_hc_2 assms(23) assms(29) assms(7) apply auto[1]
   apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                Reg T2 {reg. reg rr1 = Suc (mb mod 2)}"], blast)
  apply (simp add: act_wp_Reg_stable_other wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)

  (* L1 L6 *)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(18) c_obs_write_diff_var_pres object_write_lifted_wp)
  (* cond value *) defer
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(17) inf.absorb_iff2 inf.coboundedI1 no_value_stable_diff_var_store wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Un_subset_iff Zero_not_Suc inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (smt Un_subset_iff Zero_not_Suc inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)

  (*L2 L6*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(18) constrained_value_stable_store_diff_var)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)


  using assms(18) lifted_transfer_intro apply blast
  apply simp
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt Collect_cong RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(16) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Collect_cong One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (rule wp_ir_pr_conj_elim2)
  apply (smt One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (* L6 L6 *)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(21) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(5) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(19) assms(5) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(5) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(21) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = Suc 0} \<inter>
                ((lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
                 (Reg T2 {reg. reg rr2 = Suc 0} \<inter> 
                   (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
                   (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))))"],blast)
  using store_hc_1 assms(22) assms(24) assms(28) assms(7) apply auto[1]
  apply (smt Un_subset_iff le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.coboundedI1 subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)

  (*L7 L6*)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(20) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(20) assms(6) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(6) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(20) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
                (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"],blast)
  using store_hc_2 assms(23) assms(29) assms(7) apply auto[1]
  apply (meson inf.coboundedI1 store_wp_Reg_stable)

  (*L1 L7*)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(18) c_obs_write_diff_var_pres object_write_lifted_wp)
  (* cond value *) defer
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(17) inf.absorb_iff2 inf.coboundedI1 no_value_stable_diff_var_store wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Un_subset_iff Zero_not_Suc inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (smt Un_subset_iff Zero_not_Suc inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (*L2 L7*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(18) constrained_value_stable_store_diff_var)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)


  using assms(18) lifted_transfer_intro apply blast
  apply simp
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt Collect_cong RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(16) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Collect_cong One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (rule wp_ir_pr_conj_elim2)
  apply (smt One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (* L6 L7*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(21) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(5) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(19) assms(5) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(5) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(21) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = Suc 0} \<inter>
                ((lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
                 (Reg T2 {reg. reg rr2 = Suc 0} \<inter> 
                   (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
                   (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))))"],blast)
  using store_hc_1 assms(22) assms(24) assms(28) assms(7) apply auto[1]
  apply (smt Un_subset_iff le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  

(*L7 L7*)
  apply (simp add: le_infI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(20) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(20) assms(6) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(6) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(20) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
                (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"],blast)
  using store_hc_2 assms(23) assms(29) assms(7) apply auto[1]
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (smt Un_subset_iff inf.coboundedI1 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)  


  (*L1 L8*)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(18) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (smt One_nat_def Suc_1 constrained_val_stable insert_commute not_mod2_eq_Suc_0_eq_0)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(18) c_obs_write_diff_var_pres object_write_lifted_wp)
  (* cond value *) defer
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(17) inf.absorb_iff2 inf.coboundedI1 no_value_stable_diff_var_store wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Un_subset_iff Zero_not_Suc inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (smt Un_subset_iff Zero_not_Suc inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (*L2 L7*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis constrained_val_stable insert_commute)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(18) constrained_value_stable_store_diff_var)
    apply (rule subset_trans[where B="lift\<^sub>1 (synced T1 x 0) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (rule subset_trans[OF lift\<^sub>1_g])
                      apply (rule object_write_lifted_wp)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
  apply(subgoal_tac "R True x v \<in>  Rds x v")
  using enabling_Vmax_sync[where v'=0 and x=x and t=T1 and w="W True x v" and v=v and t'=T2]
                      apply(simp add: not_value_def)
  apply(rule subset_trans[where B=" \<langle>G (T1, W True x v)\<rangle> (\<langle>T2 \<triangleright> Rds x v\<rangle> (synced T2 x v))"])
  apply blast using act_Tr_set_wp apply (meson interpolation_right set_eq_subset)
  using R_Rds apply blast 
                      apply fastforce

    apply (rule subset_trans[where B=" lift\<^sub>1 (\<langle>G (T2, R True x v)\<rangle> (synced T2 m (mb mod 2 + v))) \<inter> lift\<^sub>1 (synced T1 m (mb mod 2 + v)) \<inter>
     lift\<^sub>1 (not_value T2 x v)"], blast)
                      apply (subgoal_tac "wval (W True x v) = Some v \<and> var (W True x v) = x")
                      apply(simp add: not_value_def)
  using assms(18) lifted_transfer_intro apply blast
  apply simp
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> (Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
             lift\<^sub>1 (synced T2 x v) \<inter>
             lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
                      apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union> 
                                                        (lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (synced T2 w (Suc 0)))"],blast)
    apply (meson Un_subset_iff empty_subsetI insert_commute not_synced_simp store_wp_Reg_stable subset_trans wp_ir_pr_disj_intro1)
  apply (rule subset_trans[where B="  lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"], blast)
  apply (smt Collect_cong RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff assms(16) no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)
  apply (simp add: le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
apply (rule subset_trans[where B="(lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union>
              lift\<^sub>1 (not_value T2 n2 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union>
              lift\<^sub>1 (not_value T2 n1 0)))"], blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (rule wp_ir_pr_disj_intro1)
  apply (smt Zero_not_Suc inf.absorb_iff2 inf_commute no_value_stable_diff_var_store store_wp_Reg_stable wp_ir_pr_conj_elim4 wp_pres_absorb)
  apply (rule wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_intro)+
  using store_wp_Reg_stable apply fastforce
  apply (smt Collect_cong One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.coboundedI1 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  apply (rule wp_ir_pr_conj_elim2)
  apply (smt One_nat_def Suc_1 T1_def T2_def T_neq Un_subset_iff inf.cobounded2 no_value_stable_diff_var_store store_wp_Reg_stable subset_trans wp_pred_sup_semi_distrib)
  apply (meson le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj3)
  apply (smt inf.coboundedI1 inf_commute store_wp_Reg_stable)

  (* L6 L7*)
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  using assms(21) constrained_value_stable_store_diff_var apply blast
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(5) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(19) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(19) assms(5) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(5) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(21) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = Suc 0} \<inter>
                ((lift\<^sub>1 (not_value T2 x 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg wr = 0}) \<union>
                 (Reg T2 {reg. reg rr2 = Suc 0} \<inter> 
                   (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
                   (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 x 0))))"],blast)
  using store_hc_1 assms(22) assms(24) assms(28) assms(7) apply auto[1]
  apply (smt Un_subset_iff le_infI1 store_wp_Reg_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  

(*L7 L7*)
  apply (simp add: le_infI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim3)
  apply (rule wp_ir_pr_conj_intro)+
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 w {0, Suc 0})"], blast)
  apply (metis assms(20) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (constrained_value T2 m {Suc 0, 2})"], blast)
  apply (metis assms(6) constrained_value_stable_store_diff_var)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 w (Suc 0)))"],blast)
  apply (metis W_var assms(20) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 m (Suc (mb mod 2))))"], blast)
  apply (metis W_var assms(20) assms(6) c_obs_write_diff_var_pres object_write_lifted_wp)
  apply (rule subset_trans[where B="Reg T2 (- {reg. reg rr2 = Suc 0}) \<union>
                lift\<^sub>1 (synced T2 m (Suc (mb mod 2))) \<inter>
                lift\<^sub>1 (synced T2 w (Suc 0))"],blast)
  apply (rule wp_ir_pr_disj_elim)+
  apply (simp add: store_wp_Reg_stable wp_ir_pr_disj_intro1)
  apply (rule wp_ir_pr_disj_intro2, rule wp_ir_pr_conj_intro)
  apply (metis W_var assms(6) inf.coboundedI1 interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (metis W_var assms(20) inf.coboundedI1 inf_commute interf_wp object_write_lifted_wp synced_value_\<beta>_stable synced_value_stable)
  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T1 r (Suc 0)) \<union>
                Reg T2 {reg. reg rr2 = Suc 0}"],blast)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff Zero_not_Suc no_value_stable_diff_var_store subset_trans wp_pred_sup_semi_distrib)  
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable wp_ir_pr_conj_elim5)
    apply (rule subset_trans[where B="Reg T1 {reg. reg wr = Suc 0} \<inter> Reg T1 {reg. reg mbr = 2} \<inter>
                (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 x 0) \<inter>
             Reg T1 {reg. reg wr = 0} \<union>
             Reg T2 {reg. reg rr2 = Suc 0} \<inter>
             (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 x 0)) \<inter>
             (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"],blast)
  using store_hc_2 assms(23) assms(29) assms(7) apply auto[1]
  apply (meson inf.coboundedI1 store_wp_Reg_stable)
  apply (smt Un_subset_iff inf.coboundedI1 store_wp_Reg_stable subset_trans wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)  

    (*L1 L8*)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
                      apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (simp add: inf.coboundedI1 inf_commute store_wp_Reg_stable)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (simp add: inf.coboundedI1 inf_commute store_wp_Reg_stable)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  apply (simp add: inf.coboundedI1 store_wp_Reg_stable)
  apply (meson inf.cobounded2 inf.coboundedI1 store_wp_Reg_stable subset_trans)
  using T_neq act_wp_Reg_stable_other apply blast
                      apply (cases pc; simp)

  apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"], blast)
  apply (metis W_var assms(18) le_infI1 object_write_lifted_wp transfer_wr_diff_var_pres) 

    apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"], blast)
  apply (metis W_var assms(18) le_infI1 object_write_lifted_wp transfer_wr_diff_var_pres) 
    apply (rule subset_trans[where B="lift\<^sub>1 (not_value T2 w (Suc 0)) \<inter> lift\<^sub>1 (\<langle>G (T2, R True w (Suc 0))\<rangle> (synced T2 x v))"], blast)
  by (metis W_var assms(18) le_infI1 object_write_lifted_wp transfer_wr_diff_var_pres) 


lemma lift_disabled:
  "lift\<^sub>1 (not_value t x v) \<subseteq> \<langle>full_step Ts Pr (t, Some (load b x r v))\<rangle> {}"
   apply(auto simp add: wp_ext constrained_value_def not_value_def full_step_def
lift\<^sub>1_def Rds_def par_step_def mem_act_def co_step_def)
  by (metis (no_types, lifting) Collect_cong ComplI DomainE R_Rds Rds_def TSys.wp_emp_not_trans not_not_value_domain not_value_def)


lemma constrained_val_split:
  assumes "P \<subseteq> lift\<^sub>1 (constrained_value t x {m, n})"
      and "P \<subseteq> \<langle>full_step Ts Pr (t, Some (load b x r m))\<rangle> Q"
      and "P \<subseteq> \<langle>full_step Ts Pr (t, Some (load b x r n))\<rangle> Q"
    shows " P \<subseteq> \<langle>full_step Ts Pr (t, Some (load b x r v))\<rangle> Q"
  apply(case_tac "v \<in> {m, n}")
  using assms(2) assms(3) apply blast
   apply(subgoal_tac "P \<subseteq> lift\<^sub>1 (not_value t x v)") 
  using lift_disabled
  using disabled_wp apply force
  apply(subgoal_tac "lift\<^sub>1 (constrained_value t x {m, n}) \<subseteq> lift\<^sub>1 (not_value t x v)")
  using assms(1) apply blast  
  by (simp add: constrained_value_implies_not_value lift\<^sub>1_mono)

lemma load_hard_case:
  assumes "ra \<noteq> mbr" and "ra \<noteq> n'" and "ra \<noteq> n''"
  shows "lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr'' = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n' 0) \<inter> lift\<^sub>1 (not_value T2 n'' 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr'' = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0)))
           \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr ra rr' rr'' a m w x n' n'')
               (T1, Some (load False x ra v))\<rangle>
               (lift\<^sub>1 (not_value T2 n' 0) \<inter> lift\<^sub>1 (not_value T2 n'' 0) \<inter>
                Reg T1 {reg. reg ra = 0} \<union>
                Reg T2 {reg. reg rr'' = Suc 0} \<inter>
                (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
                (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0)))"
  apply(rule constrained_val_split) apply blast
    apply(rule wp_ir_pr_conj_elim2)
   apply(rule wp_ir_pr_disj_elim) apply(rule wp_ir_pr_disj_intro1)
apply(rule wp_ir_pr_conj_intro)+
  apply (simp add: le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable)
     apply (metis inf_commute le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable)
  using load_wp_Reg apply blast
   apply(rule wp_ir_pr_disj_intro2)
   apply(rule wp_ir_pr_conj_intro)+
  
  using T_neq act_wp_Reg_stable_other apply blast
   apply(rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
   apply(rule wp_ir_pr_disj_elim)
  apply (metis assms(1) load_wp_Reg5 wp_ir_pr_disj_intro1)
  apply (meson RWActions.load_wp_\<beta>_stable RWActions_axioms not_value_\<beta>_stable wp_ir_pr_disj_intro2)
   apply(rule wp_ir_pr_conj_elim2)
   apply(rule wp_ir_pr_disj_elim)
   apply(rule wp_ir_pr_disj_intro1)
  apply (metis assms(1) load_wp_Reg5)
  apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_disj_intro2)

  apply(rule subset_trans [where B="(lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> (Reg T2 {reg. reg rr'' = Suc 0}) \<inter>
    (lift\<^sub>1 (not_value T2 n' 0) \<inter> lift\<^sub>1 (not_value T2 n'' 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
     Reg T2 {reg. reg rr'' = Suc 0} \<inter>
     (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n'' 0)) \<inter>
     (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n' 0))))"])
    apply blast
    apply(rule wp_ir_pr_disj_elim)
    apply (metis (no_types, lifting) R_Rds TSys.wp_emp_not_trans lift\<^sub>1_mono load_wp_Reg_neg not_value_def pres_intro)

   apply(rule wp_ir_pr_disj_intro2)
   apply(rule wp_ir_pr_conj_intro)+
    apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)
   apply(rule wp_ir_pr_conj_elim2)
   apply(rule wp_ir_pr_disj_elim)
  apply (meson RWActions.load_wp_\<beta>_stable RWActions_axioms dual_order.trans inf.cobounded2 not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro2)
   apply(rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_disj_elim)
   apply(rule wp_ir_pr_disj_intro1)
  apply (metis assms(1) load_wp_Reg5)
  
  apply (meson RWActions.load_wp_\<beta>_stable RWActions_axioms not_value_\<beta>_stable wp_ir_pr_disj_intro2)
   apply(rule wp_ir_pr_conj_elim2)
   apply(rule wp_ir_pr_disj_elim)
   apply(rule wp_ir_pr_disj_intro2)
  apply (simp add: le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable)
   apply(rule wp_ir_pr_conj_elim2)
   apply(rule wp_ir_pr_disj_elim)
   apply(rule wp_ir_pr_disj_intro1)
  apply (metis assms(1) load_wp_Reg5)
  by (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_disj_intro2)



lemma NI_load:
  assumes
       "d \<noteq> f"
  and "rr1 \<noteq> rr2"
  and "mb\<in>{1,2}"
  and "a \<noteq> rr1"
  and "m \<noteq> n1"
  and "m \<noteq> n2"
  and "n1 \<noteq> n2"
  and "wr \<noteq> rr1"
  and "a \<noteq> rr1"
  and "a \<noteq> rr2"
  and "mbr \<noteq> a"
  and "mbr \<noteq> rr1"
  and "mbr \<noteq> rr2"
  and "mbr \<noteq> wr"
  and "wr \<noteq> r"
  and "r \<noteq> w"
  and "r \<noteq> m"
  and "m \<noteq> w"
  and "w \<noteq> n1"
  and "w \<noteq> n2"
  and "n1 \<noteq> w"
  and "n1 \<noteq> mbr"
  and "n2 \<noteq> mbr"
  and "n1 \<noteq> rr2"
  and "n2 \<noteq> rr2"
  and "n1 \<noteq> rr1"
  and "n2 \<noteq> rr1"
  and "n1 \<noteq> wr"
  and "n2 \<noteq> wr"
  and a1: "t' \<in> {T1, T2}"
  and a2: "t' \<noteq> t"
  and a3: "rcu mb mbr wr rr1 rr2 a m w r n1 n2 t' pc' = loadc b ra x pc''"
  shows "outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc \<inter>
       outline mb mbr wr rr1 rr2 a m w r n1 n2 t' pc'
       \<subseteq> \<langle>full_step {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 n2)
           (t', Some (load b x ra v))\<rangle>
           (outline mb mbr wr rr1 rr2 a m w r n1 n2 t pc)"
   using a1 a2 a3 apply(simp add: outline_def)
   apply(case_tac "t")
      apply(intro conjI impI; case_tac pc; case_tac pc'; simp add: T1_def T2_def)
  apply(intro conjI impI; case_tac pc; case_tac pc'; simp; (rule wp_ir_pr_conj_intro)+)
  using act_wp_Reg_stable_other apply blast
  apply (rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (metis assms(12) load_wp_Reg_other)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf.coboundedI1 inf_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: inf.coboundedI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (simp add: le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  using constrained_value_stable_load apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  apply (rule wp_ir_pr_conj_elim2)
  apply (metis assms(11) load_wp_Reg_other)
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf.coboundedI1 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: inf.coboundedI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (meson dual_order.trans inf.cobounded2 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim3)
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  using act_wp_Reg_stable_other apply blast
   apply (rule wp_ir_pr_conj_elim2)
   apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
   apply (rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: load_wp_Reg_other)
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf.coboundedI1 inf_sup_aci(1) load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: inf.coboundedI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (meson dual_order.trans inf.cobounded2 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim3)
                      apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  using act_wp_Reg_stable_other apply blast
   apply (rule wp_ir_pr_conj_elim2)
   apply (rule wp_ir_pr_conj_elim1)
   apply (rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: load_wp_Reg_other)
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (simp add: le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  using constrained_value_stable_load apply blast
  using act_wp_Reg_stable_other apply blast 
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf.coboundedI1 inf_sup_aci(1) load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: inf.coboundedI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  using act_wp_Reg_stable_other apply blast 
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf.coboundedI1 inf_sup_aci(1) load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: inf.coboundedI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  using act_wp_Reg_stable_other apply blast  
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf.coboundedI1 inf_sup_aci(1) load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: inf.coboundedI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  using act_wp_Reg_stable_other apply blast  
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1 , rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (metis inf_sup_aci(1) le_infI1 load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (metis inf.coboundedI1 inf_sup_aci(1) load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: inf.coboundedI1 load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load inf_sup_aci(1) le_infI1)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load inf_sup_aci(1) le_infI1)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)                                     
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)                
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)                
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)                
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)                
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: constrained_value_stable_load le_infI1 wp_ir_pr_conj_elim5)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1)                
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 inf_commute)+
  using act_wp_Reg_stable_other apply blast
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 inf_commute)+
  using act_wp_Reg_stable_other apply blast
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 inf_commute)+
  using act_wp_Reg_stable_other apply blast
     apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  using assms 
  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other) 
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 inf_commute)+
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(12) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(11) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(11) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(13) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(12) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(11) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(11) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(13) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(12) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(11) load_wp_Reg_other)

  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms(11) load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms load_wp_Reg_other)
  using act_wp_Reg_stable_other apply blast
  apply (rule subset_trans[where B="Reg T2 {reg. reg mbr = mb}"],blast)
  apply (metis assms load_wp_Reg_other)
  
  

  using assms  apply (simp add: assms(10) assms(11) assms(13) assms(14) assms(7) load_wp_Reg_other)

                      apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 inf_commute)
                      apply (metis assms(13) inf.coboundedI1 inf_commute load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast
  using constrained_value_stable_load apply blast+
                      apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)

  apply (smt inf.absorb_iff2 inf_le2 le_inf_iff load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_conj_elim3)
                      apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (rule wp_ir_pr_disj_elim, rule wp_ir_pr_disj_intro1)
  apply (simp add: load_wp_\<beta>_stable not_value_\<beta>_stable)
  apply (simp add: load_wp_\<beta>_stable synced_value_\<beta>_stable wp_ir_pr_disj_intro2)

  using T_neq act_wp_Reg_stable_other apply blast
  using T_neq act_wp_Reg_stable_other apply blast
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)

  apply (metis load_wp_Reg load_wp_synced_value)
  using T_neq act_wp_Reg_stable_other apply blast


  apply (simp add: le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (simp add: le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim5)
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast
 
  apply (simp_all add: r_inv_def; (rule wp_ir_pr_conj_intro)+)
  using constrained_value_stable_load inf_left_commute apply blast
  using constrained_value_stable_load inf_left_commute apply blast
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)

  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (smt RWActions.load_wp_\<beta>_stable RWActions_axioms RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 synced_value_\<beta>_stable wp_ir_pr_conj_elim4 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pres_absorb)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim2)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 inf.coboundedI1 load_wp_\<beta>_stable not_value_\<beta>_stable wp_pred_sup_semi_distrib)
  using T_neq act_wp_Reg_stable_other apply blast

  apply (rule subset_trans[where B="
lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
                      apply blast
  using assms using load_hard_case[where ra="wr" and n'="n1" and n''="n2" and  mbr="mbr" and rr'="rr1" and rr''="rr2" and x=x and mb="mb" and a="a" and m=m and v=v and w="w"]
  apply simp
  apply (rule wp_ir_pr_conj_elim2)
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast


  (*Expanding r_inv *)
  apply (simp_all add: r_inv_def; (rule wp_ir_pr_conj_intro)+)
  using constrained_value_stable_load inf_left_commute apply blast
  using constrained_value_stable_load inf_left_commute apply blast
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (smt RWActions.load_wp_\<beta>_stable RWActions_axioms RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 synced_value_\<beta>_stable wp_ir_pr_conj_elim4 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pres_absorb)

  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)

  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  
  using T_neq act_wp_Reg_stable_other apply blast

  apply (rule subset_trans[where B="
lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
  apply blast
  using assms apply (simp add: load_hard_case)

  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1) 
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast

  (*Expanding r_inv *)
  apply (simp_all add: r_inv_def; (rule wp_ir_pr_conj_intro)+)
  using constrained_value_stable_load inf_left_commute apply blast
  using constrained_value_stable_load inf_left_commute apply blast
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (smt RWActions.load_wp_\<beta>_stable RWActions_axioms RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 synced_value_\<beta>_stable wp_ir_pr_conj_elim4 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pres_absorb)

  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)

  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  
  using T_neq act_wp_Reg_stable_other apply blast

  apply (rule subset_trans[where B="
lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
  apply blast
  using assms apply (simp add: load_hard_case)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1) 
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast


  (*Expanding r_inv *)
  apply (simp_all add: r_inv_def; (rule wp_ir_pr_conj_intro)+)
  using constrained_value_stable_load inf_left_commute apply blast
  using constrained_value_stable_load inf_left_commute apply blast
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2)
  apply (smt RWActions.load_wp_\<beta>_stable RWActions_axioms RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 synced_value_\<beta>_stable wp_ir_pr_conj_elim4 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pres_absorb)

  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)

  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1)
  
  using T_neq act_wp_Reg_stable_other apply blast

  apply (rule subset_trans[where B="
lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
  apply blast
  using assms apply (simp add: load_hard_case)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)
  apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1) 
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast

  (*Expanding r_inv *)
  apply (simp_all add: r_inv_def; (rule wp_ir_pr_conj_intro)+)
  using constrained_value_stable_load inf_left_commute apply blast
  using constrained_value_stable_load inf_left_commute apply blast
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2) 
  apply (rule wp_ir_pr_disj_elim)
  apply (simp add: act_wp_Reg_stable_other wp_ir_pr_disj_intro1)
  apply (smt RWActions.load_wp_\<beta>_stable RWActions_axioms inf.absorb_iff2 synced_value_\<beta>_stable wp_ir_pr_conj_elim4 wp_ir_pr_disj_intro2 wp_pres_absorb)
  apply (rule wp_ir_pr_conj_elim1, rule wp_ir_pr_conj_elim2, rule wp_ir_pr_conj_elim1) 
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 inf.coboundedI1 load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim5 wp_pred_sup_semi_distrib)
  using T_neq act_wp_Reg_stable_other apply blast

  apply (rule subset_trans[where B="
lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
  apply blast
  using assms apply (simp add: load_hard_case)
  apply (rule wp_ir_pr_conj_elim1)
  apply (rule wp_ir_pr_conj_elim1)
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  apply (rule wp_ir_pr_conj_elim1)
  apply (rule wp_ir_pr_conj_elim1)
  using T_neq act_wp_Reg_stable_other apply blast


  (*Expanding r_inv *)
  apply (simp_all add: r_inv_def; (rule wp_ir_pr_conj_intro)+)
  using constrained_value_stable_load inf_left_commute apply blast
  using constrained_value_stable_load inf_left_commute apply blast
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)

  apply (rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,
  rule wp_ir_pr_conj_elim2,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim2)
  apply (smt RWActions.load_wp_\<beta>_stable RWActions_axioms RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 synced_value_\<beta>_stable wp_ir_pr_conj_elim4 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pres_absorb)
  apply (rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim2)
  apply (simp add: act_wp_Reg_stable_other le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
               apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 wp_ir_pr_conj_elim5)
  apply (rule subset_trans[where B="
lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
  apply blast
  using assms apply (simp add: load_hard_case)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast

  apply (simp_all add: r_inv_def; (rule wp_ir_pr_conj_intro)+)
  using constrained_value_stable_load inf_left_commute apply blast
  using constrained_value_stable_load inf_left_commute apply blast
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)
  apply (smt G_\<beta>_stable bool_alg_inf1 inf.absorb_iff2 inf_left_commute load_wp_\<beta>_stable synced_value_\<beta>_stable)

  apply (rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,
  rule wp_ir_pr_conj_elim2,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim2)
  apply (smt RWActions.load_wp_\<beta>_stable RWActions_axioms RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq Un_subset_iff inf.absorb_iff2 synced_value_\<beta>_stable wp_ir_pr_conj_elim4 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_pres_absorb)
  apply (rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim1,rule wp_ir_pr_conj_elim2)
  apply (simp add: act_wp_Reg_stable_other le_infI1 load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim5 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2)
               apply (simp add: act_wp_Reg_stable_other inf.coboundedI1 wp_ir_pr_conj_elim5)
  apply (rule subset_trans[where B="
lift\<^sub>1 (constrained_value T1 x {0, Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T1 x (Suc 0)) \<union> Reg T2 {reg. reg rr2 = Suc 0}) \<inter>
           (lift\<^sub>1 (not_value T2 n1 0) \<inter> lift\<^sub>1 (not_value T2 n2 0) \<inter> Reg T1 {reg. reg ra = 0} \<union>
            Reg T2 {reg. reg rr2 = Suc 0} \<inter>
            (Reg T1 (- {reg. reg mbr = Suc 0}) \<union> lift\<^sub>1 (not_value T2 n2 0)) \<inter>
            (Reg T1 (- {reg. reg mbr = 2}) \<union> lift\<^sub>1 (not_value T2 n1 0)))"])
  apply blast
  using assms apply (simp add: load_hard_case)
  apply (smt RWVarsActions.act_wp_Reg_stable_other RWVarsActions_axioms T_neq inf.absorb_iff2 inf_commute load_wp_\<beta>_stable not_value_\<beta>_stable wp_ir_pr_conj_elim3 wp_ir_pr_disj_intro1 wp_ir_pr_disj_intro2 wp_ir_pr_pre_disj2)
  apply (metis assms(14) inf.coboundedI1 load_wp_Reg_other)
  using T_neq act_wp_Reg_stable_other apply blast

  by (simp add: act_wp_Reg_stable_other inf.coboundedI1 inf_commute)






lemma noninterference_rcu:
  assumes     "d \<noteq> f"
  and "rr1 \<noteq> rr2"
  and "mb\<in>{1,2}"
  and "a \<noteq> rr1"
  and "m \<noteq> n1"
  and "m \<noteq> n2"
  and "n1 \<noteq> n2"
  and "wr \<noteq> rr1"
  and "a \<noteq> rr1"
  and "a \<noteq> rr2"
  and "mbr \<noteq> a"
  and "mbr \<noteq> rr1"
  and "mbr \<noteq> rr2"
  and "mbr \<noteq> wr"
  and "wr \<noteq> r"
  and "r \<noteq> w"
  and "r \<noteq> m"
  and "m \<noteq> w"
  and "w \<noteq> n1"
  and "w \<noteq> n2"
  and "n1 \<noteq> w"
  and "n1 \<noteq> mbr"
  and "n2 \<noteq> mbr"
  and "n1 \<noteq> rr2"
  and "n2 \<noteq> rr2"
  and "n1 \<noteq> rr1"
  and "n2 \<noteq> rr1"
  and "n1 \<noteq> wr"
  and "n2 \<noteq> wr"
  shows "noninterference  {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 n2) (outline mb mbr wr rr1 rr2 a m w r n1 n2) t"

  apply(rule noninterference_cases)
  using outline_arb_pc 
  using assms(3) apply auto[1]
  using assms NI_load[where d=d] apply auto[1]
  using assms NI_store[where d=d] apply auto[1]
  using outline_def
   apply(case_tac "t=T1")
    apply(case_tac pc; case_tac pc'; simp ; (rule wp_ir_pr_conj_intro)+)
   apply(case_tac pc; case_tac pc'; auto)
  using assms NI_storee[where d=d] apply auto[1]
  using outline_def
   apply(case_tac "t=T1")
   apply(case_tac pc; case_tac pc'; auto)
  by(case_tac pc; case_tac pc'; auto)

  

definition "rcu_init mb mbr wr rr1 rr2 a m w r n1 n2  \<equiv> 
    {s . thr_pc s T1 = L1} \<inter>  {s . thr_pc s T2 = L1} 
    \<inter> Reg T1 (reg mbr mb) \<inter> Reg T2 (reg mbr mb)
    \<inter> lift\<^sub>1(synced T1 a 0) \<inter> lift\<^sub>1(synced T2 a 0)
    \<inter> lift\<^sub>1(synced T1 m mb) \<inter> lift\<^sub>1(synced T2 m mb)
    \<inter> lift\<^sub>1(synced T1 w 0) \<inter> lift\<^sub>1(synced T2 w 0)
    \<inter> lift\<^sub>1(synced T1 r 0) \<inter> lift\<^sub>1(synced T2 r 0)
    \<inter> lift\<^sub>1(not_value T1 n1 0) \<inter> lift\<^sub>1(not_value T2 n1 0)
    \<inter> lift\<^sub>1(not_value T1 n2 0) \<inter> lift\<^sub>1(not_value T2 n2 0) 
    \<inter> Reg T1 (reg rr1 0) 
    \<inter> Reg T2 (reg rr1 0) 
    \<inter> Reg T1 (reg rr2 0) 
    \<inter> Reg T2 (reg rr2 0) 
    \<inter> Reg T1 (reg wr 0) 
    \<inter> Reg T2 (reg wr 0) 
    \<inter> Reg T1 (- {reg. reg a = 0})
    \<inter> Reg T2 (- {reg. reg a = 0})"

definition "varss mb mbr wr rr1 rr2 a m w r n1 n2 \<equiv> mb \<noteq> mbr
       \<and> mb \<noteq> wr \<and> mb \<noteq> rr1 \<and> mb \<noteq> rr2 \<and> mb \<noteq> a \<and> mb \<noteq> a \<and> mb \<noteq> m 
       \<and> mb \<noteq> w \<and> mb \<noteq> r \<and> mb \<noteq> n1 \<and> mb \<noteq> n2
       \<and> mbr \<noteq> wr \<and> mbr \<noteq> rr1 \<and> mbr \<noteq> rr2 \<and> mbr \<noteq> a
       \<and> mbr \<noteq> a \<and> mbr \<noteq> m \<and>  mbr \<noteq> w \<and> mbr \<noteq> r
       \<and> mbr \<noteq> n1 \<and> mbr \<noteq> n2 \<and> wr \<noteq> rr1 \<and> wr \<noteq> rr2 
       \<and> wr \<noteq> a \<and> wr \<noteq> a \<and> wr \<noteq> m \<and> wr \<noteq> w \<and> wr \<noteq> r 
       \<and> wr \<noteq> n1 \<and> wr \<noteq> n2 
       \<and> rr1 \<noteq> rr2 \<and> rr1 \<noteq> a \<and>  rr1 \<noteq> a \<and> rr1 \<noteq> m 
       \<and> rr1 \<noteq> w \<and> rr1 \<noteq> r \<and> rr1 \<noteq> n1 \<and> rr1 \<noteq> n2
       \<and> rr2 \<noteq> a \<and> rr2 \<noteq> m 
       \<and> rr2 \<noteq> w \<and> rr2 \<noteq> r \<and> rr2 \<noteq> n1 \<and> rr2 \<noteq> n2
       \<and> a \<noteq> m \<and> a \<noteq> w \<and> a \<noteq> r \<and> a \<noteq> n1 \<and> a \<noteq> n2  
       \<and> m \<noteq> w \<and> m \<noteq> r \<and> m \<noteq> n1 \<and> m \<noteq> n2 
       \<and> w \<noteq> r \<and> w \<noteq> n1 \<and> w \<noteq> n2 \<and> r \<noteq> n1 \<and> r \<noteq> n2 \<and> n1 \<noteq> n2"


lemma synced_implies_constrained: "v\<in>V \<Longrightarrow> synced t x v \<subseteq> constrained_value t x V"
  apply(simp add: constrained_value_def)
    using def_value_def synced_def by auto

lemma synced_diff_val_cobs: "v \<noteq> v' \<Longrightarrow> synced t x v' \<subseteq> (\<langle>G (t, R True x v)\<rangle>
               (synced t y u))"
  by (metis R_Rds act_Tr_set disabled_wp2 initial_not_value interpolation_left)

theorem
  assumes "varss mb mbr wr rr1 rr2 a m w r n1 n2"
      and "mb\<in>{1,2}"
      shows "reach (\<Union> e. full_step {T1, T2} (rcu mb mbr wr rr1 rr2 a m w r n1 n2) e) (rcu_init mb mbr wr rr1 rr2 a m w r n1 n2) \<subseteq> inv_of {T1, T2} (outline mb mbr wr rr1 rr2 a m w r n1 n2)"
    apply(rule owicki_gries[OF local_correctness_rcu noninterference_rcu])
   using assms apply(simp_all add: varss_def)  apply blast+
  apply(simp add: rcu_init_def outline_def)
  apply(case_tac "t", simp_all)
    apply (simp add: T1_def T2_def)
   apply rule
   apply rule
   apply rule
   apply rule
     apply rule
   using T_neq apply auto[1]
   using T_neq apply auto[1]
    apply(intro impI conjI)
   using synced_implies_constrained
    apply (metis (no_types, hide_lams) in_mono insert_iff lift\<^sub>1_mono)
   using synced_implies_constrained
             apply (metis (no_types, hide_lams) in_mono insert_iff lift\<^sub>1_mono)
            apply(elim conjE)
   using synced_diff_val_cobs[where x=w and v'=0 and v = "Suc 0"]
   apply (metis (no_types, lifting) in_mono lift\<^sub>1_mono numeral_1_eq_Suc_0 zero_neq_numeral)
   using synced_diff_val_cobs[where x=w and v'=0 and v = "Suc 0"]
           apply (metis (no_types, lifting) in_mono lift\<^sub>1_mono numeral_1_eq_Suc_0 zero_neq_numeral)
   apply(intro disjI1)
   apply(simp add: synced_def)
   apply (metis def_value_implies_not_value inf_sup_ord(1) lift\<^sub>1_mono numeral_1_eq_Suc_0 subsetD zero_neq_numeral)
    apply(intro impI conjI)
    apply(simp add: synced_def)
     apply (metis def_value_implies_not_value inf_sup_ord(1) lift\<^sub>1_mono numeral_1_eq_Suc_0 subsetD zero_neq_numeral)
   apply (meson in_mono insert_iff lift\<^sub>1_mono synced_implies_constrained)
      by blast
end
